// This do-file runs cross-country regressions on how the level of circumcision
// is correlated with the HIV prevalence (and other controls)

clear

set more off

// Start log
capture log close
log using circ_regs_log.txt, text replace

// Load data
use cross_country

// Generate other variables
local religion christian muslim

// Run regressions - with prevalence rates
reg hiv circ lgdppc art_prev syphilis
reg hiv circ lgdppc art_prev syphilis muslim
reg hiv circ lgdppc art_prev syphilis `religion'
reg hiv circ lgdppc condom_price art_prev syphilis `religion'

// Run regressions - with incidence
reg hiv_incid circ lgdppc art_prev syphilis
reg hiv_incid circ lgdppc art_prev syphilis muslim
reg hiv_incid circ lgdppc art_prev syphilis `religion'
reg hiv_incid circ lgdppc condom_price art_prev syphilis `religion'

// Close log file
log close

