set more off, permanently

* Insert absolute path of moments96 folder on your disk here
cd "C:\Users\YOU\moments1996_2004"

clear all

set maxvar 8000

* Set relative paths
global workdata= ".\workdata\"
global rawdata= ".\rawdata\"
global outdat= ".\outdat\"

***Women***
use "$rawdata\MWIQ34FL.dta",replace

* women married who report having had sex in the past 12 month
gen any_sex_union=1 if (inrange(q415u,1,3)|((q415u==4)&(q415n==1)))
replace any_sex_union=0 if q415u==3&q415n>12
replace any_sex_union=0 if q415u==4&(q415n>1)


gen married=(q402==1)
gen living=(q402==2)
gen nounion=(q402==3)


* women fraction of singles (including living together)
gen single=(q402==3)|(q402==2)

preserve
collapse single [w=qweight]
save "$outdat\frac_single_incliving_women96.dta", replace
restore


* women fraction of singles (not including living together)
gen single_living=(q402==3)

preserve
collapse single_living [w=qweight]
save "$outdat\frac_single_noliving_women96.dta", replace
restore

* women not married who report sex having had sex in the past 12 month
gen any_sex_nounion=1 if inrange(q416hu,1,3)|((q416hu==4)&(q416hn==1))
replace any_sex_union=0 if q416hu==3&q416hn>12
replace any_sex_union=0 if q416hu==4&(q416hn>1)
replace any_sex_nounion=0 if q416hu==0

gen any_sex= any_sex_union if (q402==1)|(q402==2)
replace any_sex= any_sex_nounion if (q402==3)


* women married or living together who report extramarital sex
gen exmarsex_union=(q416b==1)
gen casual_sex=(any_sex_nounion==1|exmarsex_union==1)

* Rate of singles having sex (living together coded as singles)
preserve
collapse any_sex [w=qweight] if (q402==3)
save "$outdat\singles_sex_women96.dta", replace
restore


* Fraction of all sex that is casual (for women)
preserve
* Weighted avg
collapse casual_sex [w=qweight] if any_sex==1
save "$outdat\frac_casualsex_women96.dta", replace
restore





***Men***
use "$rawdata\mwml34fl.dta",replace

* men fraction of singles (including living together)
gen single=(qm402==3)|(qm402==2)

preserve
collapse single [w=qweight] 
save "$outdat\frac_single_incliving_men96.dta", replace
restore


* men fraction of singles (not including living together)
gen single_living=(qm402==3)

preserve
collapse single_living [w=qweight]
save "$outdat\frac_single_noliving_men96.dta", replace
restore


* men married who report having had sex in the past 12 months
gen any_sex_union=1 if (inrange(qm415u,1,3)|((qm415u==4)&(qm415n==1)))
replace any_sex_union=0 if qm415u==3&qm415n>12
replace any_sex_union=0 if qm415u==4&(qm415n>1)


* men not married who report sex having had sex in the past 12 months
gen any_sex_nounion=1 if (inrange(qm416hu,1,3)|((qm416hu==4)&(qm416hn==1)))
replace any_sex_union=0 if qm416hu==3&qm416hn>12
replace any_sex_union=0 if qm416hu==4&(qm416hn>1)
replace any_sex_nounion=0 if qm416hu==0

gen any_sex= any_sex_union if (qm402==1)|(qm402==2)
replace any_sex= any_sex_nounion if (qm402==3)

* men married or living together who report extramarital sex
gen exmarsex_union=(qm416b==1)
gen casual_sex=(any_sex_nounion==1|exmarsex_union==1)




* Rate of singles having sex (living together coded as singles)
preserve
collapse any_sex [aweight=qweight] if (qm402==3)
save "$outdat\singles_sex_men96.dta", replace
restore

* Fraction of all sex that is casual (for men)
preserve
* Weighted avg
collapse casual_sex [aweight=qweight] if any_sex==1
save "$outdat\frac_casualsex_men96.dta", replace
restore




