subroutine abstinence(mytype,mygender,mystatus,ntypes,income,v_l,vtilde)
!This function computes the utility from being abstinence for older agents
use mod_param
implicit none

!Define dummy variables:
integer     , intent(in)  :: mytype
integer     , intent(in)  :: mygender
integer     , intent(in)  :: mystatus
integer     , intent(in)  :: ntypes
real(mykind), intent(in)  :: income
real(mykind), intent(in)  :: v_l(n_status,ntypes)
real(mykind), intent(out) :: vtilde

!Define parameters for this problem:
real(mykind) :: beta, A

!Define other variables:
real(mykind) :: util

!-----------------------------------------------------

!Get variables:
if (mygender==i_male) then
    beta = beta_m(mytype)
    A = A_m(mytype)
elseif (mygender==i_female) then
    beta = beta_f(mytype)
    A = A_f(mytype)
else
    print *, 'wrong gender in abstinence'
    read *, beta
endif

!Utility from consumption:
call utility(income,util)

!Value function:
if (mystatus==i_healthy) then
    vtilde = util + beta*v_l(i_healthy,mytype)
else
    vtilde = util + (1.0-alpha_vec(mystatus))*beta*(q_vec(mystatus)*v_l(i_treated,mytype)+(1.0-q_vec(mystatus))*v_l(i_sick,mytype)) + alpha_vec(mystatus)*beta*A
endif

end subroutine abstinence
