subroutine allocate_arrays

use mod_param
implicit none

!Vectors to hold the type-specific parameters:
allocate (parameters_bytype_m(ntypes_m*nparam_bytype))
allocate (parameters_bytype_f(ntypes_f*nparam_bytype))

!Vectors for type-specific parameters:
allocate (A_m(ntypes_m))
allocate (iota_m(ntypes_m))
allocate (beta_m(ntypes_m))
allocate (mu_m(ntypes_m))
allocate (chi_m(ntypes_m))
allocate (util_l_m(ntypes_m))
allocate (A_f(ntypes_f))
allocate (iota_f(ntypes_f))
allocate (beta_f(ntypes_f))
allocate (mu_f(ntypes_f))
allocate (chi_f(ntypes_f))
allocate (util_l_f(ntypes_f))

!Vectors for search effort:
allocate (search_p(1,ngrid))
allocate (search_u(1,ngrid))
allocate (search_l(1,ngrid))
allocate (search_ucon(1,ngrid))
allocate (mygrid(ngrid))
allocate (mygrid_con(ngrid))

!Vectors for value functions - males:
allocate (v_next_m(n_age*n_status*ntypes_m))
allocate (v1_m(n_age*n_status*ntypes_m))
allocate (v0_m(n_age*n_status*ntypes_m))

!Vectors for value functions - females:
allocate (v_next_f(n_age*n_status*ntypes_f))
allocate (v1_f(n_age*n_status*ntypes_f))
allocate (v0_f(n_age*n_status*ntypes_f))

!Vectors for distributions - males:
allocate (dist_next_m(n_age*n_status*ntypes_m))
allocate (dist0_m(n_age*n_status*ntypes_m))
allocate (dist1_m(n_age*n_status*ntypes_m))

!Vectors for distributions - females:
allocate (dist_next_f(n_age*n_status*ntypes_f))
allocate (dist0_f(n_age*n_status*ntypes_f))
allocate (dist1_f(n_age*n_status*ntypes_f))

!Prevalence rates for each iteration:
allocate (phi_p_m_iter(max_iter))
allocate (phi_u_m_iter(max_iter))
allocate (phi_l_m_iter(max_iter))
allocate (phi_p_f_iter(max_iter))
allocate (phi_u_f_iter(max_iter))
allocate (phi_l_f_iter(max_iter))

end subroutine allocate_arrays
