function out = bisection(vgap,omeg,kap,b)
%This function finds the zero of foc, the first order condition for the
%unconstrained search effort in the short term market

%PARAMETERS
xlow = 0;     % lower bound
xup = b - .00000001;      % upper bound
i = 0;        % number of iterations
tol = 1E-10;  % tolerance

%INITIAL INTERVAL
fxlow = foc(xlow,vgap,omeg,kap,b);   % function at lower bound
fxup = foc(xup,vgap,omeg,kap,b);     % function at upper bound

if fxlow*fxup > 0
    error('Bisection cannot continue - Function at endpoints has the same sign')
else

    %LOOP
    fx = 5;
    while abs(fx) > tol && i <= 100
    
        x = (xlow + xup)/2;  % new guess
        fx = foc(x,vgap,omeg,kap,b);   % function evaluated at the new guess
    
        % the following improves the bounds
        if (fxup * fx) <= 0
            xlow = x;
            %fxlow = fx;
        else
            xup = x;
            fxup = fx;
        end
    
        i = i+1;
    
    end
    
    out = x;
end