function out = bisection_con(vgap,omeg_p,omeg_u,kap_p,kap_u,b_p,b_u)
%This function finds the zero of foc_con, the first order condition for the
%constrained search effort in the short term market

%PARAMETERS
xlow = 1 - b_p + 0.000001;     % lower bound
xup = b_u - .0000001;      % upper bound
i = 0;        % number of iterations
tol = 1E-10;  % tolerance
param = [vgap,omeg_p,omeg_u,kap_p,kap_u,b_p,b_u];

%INITIAL INTERVAL
fxlow = foc_con(xlow,param);   % function at lower bound
fxup = foc_con(xup,param);     % function at upper bound

if fxlow*fxup > 0
    error('Bisection cannot continue - Function at endpoints has the same sign')
else

    %LOOP
    fx = 5;
    while abs(fx) > tol && i <= 100
    
        x = (xlow + xup)/2;  % new guess
        fx = foc_con(x,param);   % function evaluated at the new guess
    
        % the following improves the bounds
        if (fxup * fx) <= 0
            xlow = x;
            %fxlow = fx;
        else
            xup = x;
            fxup = fx;
        end
    
        i = i+1;
    
    end
    
    out = x;
end