subroutine compute_frac_healthy_longterm_bycirc(pi_l_m,pi_l_y_m,dist_S_m,dist_S_y_m,total_measure,frac_healthy_nocirc_m,frac_healthy_circ_m)
use mod_param
implicit none

!Define dummy variables:
real(mykind), intent(in) :: pi_l_m(n_status,ntypes_m)
real(mykind), intent(in) :: pi_l_y_m(n_status,ntypes_m)
real(mykind), intent(in) :: dist_S_m(n_status,ntypes_m)
real(mykind), intent(in) :: dist_S_y_m(n_status,ntypes_m)
real(mykind), intent(in) :: total_measure
real(mykind), intent(out) :: frac_healthy_nocirc_m
real(mykind), intent(out) :: frac_healthy_circ_m

!Define other variables for distributions:
real(mykind) :: dist_nocirc(n_status,ntypes_m/2)
real(mykind) :: dist_nocirc_y(n_status,ntypes_m/2)
real(mykind) :: dist_circ(n_status,ntypes_m/2)
real(mykind) :: dist_circ_y(n_status,ntypes_m/2)

!Define other variables for policy functions:
real(mykind) :: pi_l_nocirc(n_status,ntypes_m/2)
real(mykind) :: pi_l_nocirc_y(n_status,ntypes_m/2)
real(mykind) :: pi_l_circ(n_status,ntypes_m/2)
real(mykind) :: pi_l_circ_y(n_status,ntypes_m/2)

!Define other variables for measures:
real(mykind) :: measure_l_nocirc(n_status)
real(mykind) :: measure_l_nocirc_y(n_status)
real(mykind) :: measure_l_circ(n_status)
real(mykind) :: measure_l_circ_y(n_status)



!-------------------------------------------------------------


if (do_misinformed==1) then

	!There are now four blocks of men:
	!Informed/non-circumcised; informed/circumcised; non-informed/non-circumcised; non-informed/circumcised
	!They happen in this order within ntypes_m
	
	!Compute the measure of men of each health status, by circumcision type
	measure_l_nocirc = sum(pi_l_m(:,1:ntypes_m/4)*dist_S_m(:,1:ntypes_m/4)+pi_l_m(:,ntypes_m/2+1:3*ntypes_m/4)*dist_S_m(:,ntypes_m/2+1:3*ntypes_m/4),dim=2) + sum(pi_l_y_m(:,1:ntypes_m/4)*dist_S_y_m(:,1:ntypes_m/4)+pi_l_y_m(:,ntypes_m/2+1:3*ntypes_m/4)*dist_S_y_m(:,ntypes_m/2+1:3*ntypes_m/4),dim=2)
	measure_l_circ = sum(pi_l_m(:,ntypes_m/4+1:ntypes_m/2)*dist_S_m(:,ntypes_m/4+1:ntypes_m/2)+pi_l_m(:,3*ntypes_m/4+1:3*ntypes_m)*dist_S_m(:,3*ntypes_m/4+1:3*ntypes_m),dim=2) + sum(pi_l_y_m(:,ntypes_m/4+1:ntypes_m/2)*dist_S_y_m(:,ntypes_m/4+1:ntypes_m/2)+pi_l_y_m(:,3*ntypes_m/4+1:3*ntypes_m)*dist_S_y_m(:,3*ntypes_m/4+1:3*ntypes_m),dim=2)
	
	!Compute fractions of healthy men in the longterm market, by circumcision type:
	frac_healthy_nocirc_m = (measure_l_nocirc(i_healthy)+measure_l_nocirc_y(i_healthy)) / total_measure
	frac_healthy_circ_m   = (measure_l_circ(i_healthy)+measure_l_circ_y(i_healthy)) / total_measure
	
else !no misinformed agents

	!Separate distributions by circumcision type:
	dist_nocirc = dist_S_m(:,1:ntypes_m/2)
	dist_nocirc_y = dist_S_y_m(:,1:ntypes_m/2)
	dist_circ = dist_S_m(:,ntypes_m/2+1:ntypes_m)
	dist_circ_y = dist_S_y_m(:,ntypes_m/2+1:ntypes_m)

	!Separate policy functions by circumcision type:
	pi_l_nocirc = pi_l_m(:,1:ntypes_m/2)
	pi_l_nocirc_y = pi_l_y_m(:,1:ntypes_m/2)
	pi_l_circ = pi_l_m(:,ntypes_m/2+1:ntypes_m)
	pi_l_circ_y = pi_l_y_m(:,ntypes_m/2+1:ntypes_m)

	!Compute measures that go into the longterm market:
	measure_l_nocirc = sum(pi_l_nocirc*dist_nocirc,dim=2)
	measure_l_nocirc_y = sum(pi_l_nocirc_y*dist_nocirc_y,dim=2)
	measure_l_circ = sum(pi_l_circ*dist_circ,dim=2)
	measure_l_circ_y = sum(pi_l_circ_y*dist_circ_y,dim=2)

	!Compute fractions of healthy men in the longterm market, by circumcision type:
	frac_healthy_nocirc_m = (measure_l_nocirc(i_healthy)+measure_l_nocirc_y(i_healthy)) / total_measure
	frac_healthy_circ_m   = (measure_l_circ(i_healthy)+measure_l_circ_y(i_healthy)) / total_measure

endif




end subroutine compute_frac_healthy_longterm_bycirc
