%This m-file computes the fraction of healthy men in the long term market
%by circumcision type

%Helpful measure:
measure_here = sum(measure_l_m+measure_l_y_m);

%Separate distributions by circumcision type:
dist_nocirc = dist_S_m(:,chi_m==1);
dist_nocirc_y = dist_S_y_m(:,chi_m==1);
dist_circ = dist_S_m(:,chi_m<1);
dist_circ_y = dist_S_y_m(:,chi_m<1);

%Separate policy functions by circumcision type:
pi_l_nocirc = pi_l_m(:,chi_m==1);
pi_l_nocirc_y = pi_l_y_m(:,chi_m==1);
pi_l_circ = pi_l_m(:,chi_m<1);
pi_l_circ_y = pi_l_y_m(:,chi_m<1);

%Compute measures that go into the longterm market:
measure_l_nocirc = sum(pi_l_nocirc.*dist_nocirc,2);
measure_l_nocirc_y = sum(pi_l_nocirc_y.*dist_nocirc_y,2);
measure_l_circ = sum(pi_l_circ.*dist_circ,2);
measure_l_circ_y = sum(pi_l_circ_y.*dist_circ_y,2);

%Compute fractions of healthy men in the longterm market, by circumcision type:
frac_healthy_nocirc_m = (measure_l_nocirc(i_healthy)+measure_l_nocirc_y(i_healthy)) / measure_here;
frac_healthy_circ_m   = (measure_l_circ(i_healthy)+measure_l_circ_y(i_healthy)) / measure_here;
