subroutine deallocate_arrays

use mod_param
implicit none

!Vectors to hold the type-specific parameters:
deallocate (parameters_bytype_m)
deallocate (parameters_bytype_f)

!Vectors for type-specific parameters:
deallocate (A_m)
deallocate (iota_m)
deallocate (beta_m)
deallocate (mu_m)
deallocate (chi_m)
deallocate (util_l_m)
deallocate (A_f)
deallocate (iota_f)
deallocate (beta_f)
deallocate (mu_f)
deallocate (chi_f)
deallocate (util_l_f)

!Vectors for search effort:
deallocate (search_p)
deallocate (search_u)
deallocate (search_l)
deallocate (search_ucon)
deallocate (mygrid)
deallocate (mygrid_con)

!Grids for value functions - males:
deallocate (v_next_m)
deallocate (v1_m)
deallocate (v0_m)

!Grids for value functions - females:
deallocate (v_next_f)
deallocate (v1_f)
deallocate (v0_f)

!Vectors for distributions - males:
deallocate (dist_next_m)
deallocate (dist0_m)
deallocate (dist1_m)

!Vectors for distributions - females:
deallocate (dist_next_f)
deallocate (dist0_f)
deallocate (dist1_f)

!Prevalence rates for each iteration:
deallocate (phi_p_m_iter)
deallocate (phi_u_m_iter)
deallocate (phi_l_m_iter)
deallocate (phi_p_f_iter)
deallocate (phi_u_f_iter)
deallocate (phi_l_f_iter)

end subroutine deallocate_arrays
