%This m-file computes life-cycle model statistics:

%Vector of ages:
allages = 1:last_age;

%Size of population of each gender by age:
n_byage_m = sum(dist_S_byage_all_m + dist_L_byage_all_m + dist_A_byage_all_m,1);
n_byage_m = n_byage_m';
n_byage_f = sum(dist_S_byage_all_f + dist_L_byage_all_f + dist_A_byage_all_f,1);
n_byage_f = n_byage_f';
n_byage_all = n_byage_m + n_byage_f;

%Computing some helpful measures:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Males:
measure_p_byage_m = zeros(last_age,1);
measure_u_byage_m = zeros(last_age,1);
measure_a_byage_m = zeros(last_age,1);
measure_l_byage_m = zeros(last_age,1);
measure_p_y_byage_m = zeros(last_age,1);
measure_u_y_byage_m = zeros(last_age,1);
measure_a_y_byage_m = zeros(last_age,1);
measure_l_y_byage_m = zeros(last_age,1);
measure_p_all_byage_m = zeros(last_age,1);
measure_u_all_byage_m = zeros(last_age,1);
measure_a_all_byage_m = zeros(last_age,1);
measure_l_all_byage_m = zeros(last_age,1);
for tt=1:last_age
    measure_p_byage_m(tt) = sum(sum((1.0-pi_l_m).*pi_p_m.*dist_S_byage_m(:,:,tt)));
    measure_u_byage_m(tt) = sum(sum((1.0-pi_l_m).*pi_u_m.*dist_S_byage_m(:,:,tt)));
    measure_a_byage_m(tt) = sum(sum((1.0-pi_l_m).*(1.0-pi_p_m-pi_u_m).*dist_S_byage_m(:,:,tt)));
    measure_l_byage_m(tt) = sum(sum(pi_l_m.*dist_S_byage_m(:,:,tt)));
    measure_p_y_byage_m(tt) = sum(sum((1.0-pi_l_y_m).*pi_p_y_m.*dist_S_byage_y_m(:,:,tt)));
    measure_u_y_byage_m(tt) = sum(sum((1.0-pi_l_y_m).*pi_u_y_m.*dist_S_byage_y_m(:,:,tt)));
    measure_a_y_byage_m(tt) = sum(sum((1.0-pi_l_y_m).*(1.0-pi_p_y_m-pi_u_y_m).*dist_S_byage_y_m(:,:,tt)));
    measure_l_y_byage_m(tt) = sum(sum(pi_l_y_m.*dist_S_byage_y_m(:,:,tt)));
    measure_p_all_byage_m(tt) = measure_p_byage_m(tt) + measure_p_y_byage_m(tt);
    measure_u_all_byage_m(tt) = measure_u_byage_m(tt) + measure_u_y_byage_m(tt);
    measure_l_all_byage_m(tt) = measure_l_byage_m(tt) + measure_l_y_byage_m(tt);
    measure_a_all_byage_m(tt) = measure_a_byage_m(tt) + measure_a_y_byage_m(tt);
end

%Females:
measure_p_byage_f = zeros(last_age,1);
measure_u_byage_f = zeros(last_age,1);
measure_a_byage_f = zeros(last_age,1);
measure_l_byage_f = zeros(last_age,1);
measure_p_y_byage_f = zeros(last_age,1);
measure_u_y_byage_f = zeros(last_age,1);
measure_a_y_byage_f = zeros(last_age,1);
measure_l_y_byage_f = zeros(last_age,1);
measure_p_all_byage_f = zeros(last_age,1);
measure_u_all_byage_f = zeros(last_age,1);
measure_a_all_byage_f = zeros(last_age,1);
measure_l_all_byage_f = zeros(last_age,1);
for tt=1:last_age
    measure_p_byage_f(tt) = sum(sum((1.0-pi_l_f).*pi_p_f.*dist_S_byage_f(:,:,tt)));
    measure_u_byage_f(tt) = sum(sum((1.0-pi_l_f).*pi_u_f.*dist_S_byage_f(:,:,tt)));
    measure_a_byage_f(tt) = sum(sum((1.0-pi_l_f).*(1.0-pi_p_f-pi_u_f).*dist_S_byage_f(:,:,tt)));
    measure_l_byage_f(tt) = sum(sum(pi_l_f.*dist_S_byage_f(:,:,tt)));
    measure_p_y_byage_f(tt) = sum(sum((1.0-pi_l_y_f).*pi_p_y_f.*dist_S_byage_y_f(:,:,tt)));
    measure_u_y_byage_f(tt) = sum(sum((1.0-pi_l_y_f).*pi_u_y_f.*dist_S_byage_y_f(:,:,tt)));
    measure_a_y_byage_f(tt) = sum(sum((1.0-pi_l_y_f).*(1.0-pi_p_y_f-pi_u_y_f).*dist_S_byage_y_f(:,:,tt)));
    measure_l_y_byage_f(tt) = sum(sum(pi_l_y_f.*dist_S_byage_y_f(:,:,tt)));
    measure_p_all_byage_f(tt) = measure_p_byage_f(tt) + measure_p_y_byage_f(tt);
    measure_u_all_byage_f(tt) = measure_u_byage_f(tt) + measure_u_y_byage_f(tt);
    measure_l_all_byage_f(tt) = measure_l_byage_f(tt) + measure_l_y_byage_f(tt);
    measure_a_all_byage_f(tt) = measure_a_byage_f(tt) + measure_a_y_byage_f(tt);
end

%HIV rates by age:
%%%%%%%%%%%%%%%%%%

%hiv_byage_m and hiv_byage_f are are already computed in results

%Both genders:
hiv_byage_all = zeros(last_age,1);
for tt=1:last_age
    hiv_byage_all(tt) = (n_byage_m(tt)*hiv_byage_m(tt)+n_byage_f(tt)*hiv_byage_f(tt)) / (n_byage_all(tt));
end

%Fraction ever married by age:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%evermarried_m and evermarried_f are are already computed in results

%Both genders:
evermarried_all = zeros(last_age,1);
for tt=1:last_age
    evermarried_all(tt) = (n_byage_m(tt)*evermarried_m(tt)+n_byage_f(tt)*evermarried_f(tt)) / (n_byage_all(tt));
end

%Fraction currently single by age:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Males:
currentlysingle_m = zeros(last_age,1);
for tt=1:last_age
    currentlysingle_m(tt) = sum(dist_S_byage_all_m(:,tt)) / n_byage_m(tt);
end

%Females:
currentlysingle_f = zeros(last_age,1);
for tt=1:last_age
    currentlysingle_f(tt) = sum(dist_S_byage_all_f(:,tt)) / n_byage_f(tt);
end

%Everyone:
currentlysingle_all = zeros(last_age,1);
for tt=1:last_age
    currentlysingle_all(tt) = sum(n_byage_m(tt)*currentlysingle_m(tt)+n_byage_f(tt)*currentlysingle_f(tt)) / n_byage_all(tt);
end

%Fraction of sex that is short term, by age:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Males:
prob_s_byage_m = zeros(last_age,1);
for tt=1:last_age
    prob_s_byage_m(tt) = (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)) ...
        / (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_l_all_byage_m(tt)+sum(dist_L_byage_all_m(:,tt)));
end

%Females:
prob_s_byage_f = zeros(last_age,1);
for tt=1:last_age
    prob_s_byage_f(tt) = (measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)) ...
        / (measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)+measure_l_all_byage_f(tt)+sum(dist_L_byage_all_f(:,tt)));
end

%Everyone:
prob_s_byage_all = zeros(last_age,1);
for tt=1:last_age
    prob_s_byage_all(tt) = (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)) ...
        / (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_l_all_byage_m(tt)+sum(dist_L_byage_all_m(:,tt))+measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)+measure_l_all_byage_f(tt)+sum(dist_L_byage_all_f(:,tt)));
end

%Given short term, fraction that used condom, by age:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Males:
prob_condom_byage_m = zeros(last_age,1);
for tt=1:last_age
    prob_condom_byage_m(tt) = (measure_p_all_byage_m(tt)) / (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt));
end

%Females:
prob_condom_byage_f = zeros(last_age,1);
for tt=1:last_age
    prob_condom_byage_f(tt) = measure_p_all_byage_f(tt) / (measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt));
end

%Everyone:
prob_condom_byage_all = zeros(last_age,1);
for tt=1:last_age
    prob_condom_byage_all(tt) = (measure_p_all_byage_m(tt)+measure_p_all_byage_f(tt)) ...
        / (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt));
end

%Fraction of singles who had sex, by age:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Males:
prob_shortsex_byage_m = zeros(last_age,1);
for tt=1:last_age
    prob_shortsex_byage_m(tt) = (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)) ...
        / (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_a_all_byage_m(tt));
end

%Females:
prob_shortsex_byage_f = zeros(last_age,1);
for tt=1:last_age
    prob_shortsex_byage_f(tt) = (measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)) ...
        / (measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)+measure_a_all_byage_f(tt));
end

%Everyone:
prob_shortsex_byage_all = zeros(last_age,1);
for tt=1:last_age
    prob_shortsex_byage_all(tt) = (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)) ...
        / (measure_p_all_byage_m(tt)+measure_u_all_byage_m(tt)+measure_a_all_byage_m(tt)+measure_p_all_byage_f(tt)+measure_u_all_byage_f(tt)+measure_a_all_byage_f(tt));
end

%Consolidate in one array:
%%%%%%%%%%%%%%%%%%%%%%%%%%

lifecycle_moments_model = [hiv_byage_m hiv_byage_f hiv_byage_all ...
    evermarried_m evermarried_f evermarried_all ...
    currentlysingle_m currentlysingle_f currentlysingle_all ...
    prob_s_byage_m prob_s_byage_f prob_s_byage_all ...
    prob_condom_byage_m prob_condom_byage_f prob_condom_byage_all ...
    prob_shortsex_byage_m prob_shortsex_byage_f prob_shortsex_byage_all ];

%Write to file:
csvwrite('lifecycle_moments.csv',lifecycle_moments_model)

%HIV deaths by age:
%%%%%%%%%%%%%%%%%%%

%Start variables:
natural_deaths_byage = zeros(last_age,1);
hiv_deaths_byage = zeros(last_age,1);
fraction_hiv_aids_byage = zeros(last_age,1);

%Compute deaths by HIV for every quarter:
for tt=1:last_age
    symptoms_now = sum(sum(dist_A_byage_m(:,:,tt))) + sum(sum(dist_A_byage_f(:,:,tt)));
    population_now = sum(sum(dist_S_byage_m(:,:,tt)+dist_S_byage_y_m(:,:,tt)+dist_L_byage_m(:,:,tt)+dist_L_byage_y_m(:,:,tt)+dist_A_byage_m(:,:,tt))) ...
        + sum(sum(dist_S_byage_f(:,:,tt)+dist_S_byage_y_f(:,:,tt)+dist_L_byage_f(:,:,tt)+dist_L_byage_y_f(:,:,tt)+dist_A_byage_f(:,:,tt)));
    natural_deaths_byage(tt) = delta * population_now;
    hiv_deaths_byage(tt) = (1-delta)*delta2 * symptoms_now;
    fraction_hiv_aids_byage(tt) = hiv_deaths_byage(tt) / (natural_deaths_byage(tt)+hiv_deaths_byage(tt));
end

%Write to file:
csvwrite('hiv_deaths_byage.csv',fraction_hiv_aids_byage)








