subroutine read_parameters_all

use mod_param
implicit none

open(11,file='parameters_all.txt',status='old')

read(11,*) t_p ! (1);
read(11,*) t_u ! (2);
read(11,*) t_l ! (3);
read(11,*) phi_p_m ! (4);
read(11,*) phi_u_m ! (5);
read(11,*) phi_l_m ! (6);
read(11,*) phi_p_f ! (7);
read(11,*) phi_u_f ! (8);
read(11,*) phi_l_f ! (9);
read(11,*) delta ! (10);
read(11,*) delta2 ! (11);
read(11,*) epsilon ! (12);
read(11,*) alpha ! (13);
read(11,*) alpha_treat ! (14);
read(11,*) gammau_m ! (15);
read(11,*) gammap_m ! (16);
read(11,*) gammau_m_treat ! (17);
read(11,*) gammap_m_treat ! (18);
read(11,*) gammau_f ! (19);
read(11,*) gammap_f ! (20);
read(11,*) gammau_f_treat ! (21);
read(11,*) gammap_f_treat ! (22);
read(11,*) q ! (23);
read(11,*) y_m ! (24);
read(11,*) y_f ! (25);
read(11,*) p_m ! (26);
read(11,*) p_f ! (27);
read(11,*) u_m ! (28);
read(11,*) u_f ! (29);
read(11,*) l_m ! (30);
read(11,*) l_f ! (31);
read(11,*) eta ! (32);
read(11,*) omega_p ! (33);
read(11,*) kappa_p ! (34);
read(11,*) b_p ! (35);
read(11,*) omega_u ! (36);
read(11,*) kappa_u ! (37);
read(11,*) b_u ! (38);
read(11,*) omega_l ! (39);
read(11,*) kappa_l ! (40);
read(11,*) b_l ! (41);
read(11,*) A_global ! (42);
read(11,*) do_circ ! (43);
read(11,*) frac_circ ! (44);
read(11,*) chi_circ ! (45);
read(11,*) beta_max ! (46);
read(11,*) beta_min ! (47);
read(11,*) iota_change ! (48);
read(11,*) placeholder ! (49);
read(11,*) placeholder ! (50);
read(11,*) n_cores ! (51);
read(11,*) expnumber ! (52);
read(11,*) ntypes_m ! (53);
read(11,*) ntypes_f ! (54);
read(11,*) do_ge ! (55);
read(11,*) max_iter ! (56);
read(11,*) tol ! (57);
read(11,*) ddd ! (58);
read(11,*) ddd1 ! (59);
read(11,*) slow ! (60);
read(11,*) slow_size ! (61);
read(11,*) use_oldstuff ! (62);
read(11,*) do_mc ! (63);
read(11,*) do_epid ! (64);
read(11,*) do_epidplus ! (65);
read(11,*) do_smallexp ! (66);
read(11,*) do_smallexpnobehav ! (67);
read(11,*) nparam_bytype ! (68);
read(11,*) ngrid ! (69);
read(11,*) ge_max_iter ! (70);
read(11,*) ge_tol ! (71);
read(11,*) ge_step ! (72);
read(11,*) do_misinformed ! (73);
read(11,*) frac_misinformed ! (74);
read(11,*) al_range ! (75);
read(11,*) al1 ! (76);
read(11,*) al2 ! (77);
read(11,*) al3 ! (78);
read(11,*) save_prev_iter ! (79);
read(11,*) fgv_server ! (80);

close(11)

!Check whether we're going to run the small scale experiments:
open(11,file='exec_epid.txt',status='old')
    read(11,*) exec_epid
close(11)

open(11,file='exec_smallexp.txt',status='old')
    read(11,*) exec_smallexp
close(11)

if (exec_epid==0 .and. exec_smallexp==0) then
    exec_bench=1
else
    exec_bench=0
endif

!Set the array for probability of getting symptoms:
alpha_vec(i_healthy) = 0.0d0
alpha_vec(i_sick)    = alpha
alpha_vec(i_treated) = alpha_treat

!Set the array for probability of getting treatment:
q_vec(i_healthy) = 0.0d0
q_vec(i_sick)    = q
q_vec(i_treated) = 1.0d0

!Set the array for non-transmission rates:
gamma_vec(i_healthy,i_male,:) = 1.0d0
gamma_vec(i_healthy,i_female,:) = 1.0d0
gamma_vec(i_sick,i_male,i_protected) = gammap_m
gamma_vec(i_sick,i_female,i_protected) = gammap_f
gamma_vec(i_sick,i_male,i_unprotected) = gammau_m
gamma_vec(i_sick,i_female,i_unprotected) = gammau_f
gamma_vec(i_treated,i_male,i_protected) = gammap_m_treat
gamma_vec(i_treated,i_female,i_protected) = gammap_f_treat
gamma_vec(i_treated,i_male,i_unprotected) = gammau_m_treat
gamma_vec(i_treated,i_female,i_unprotected) = gammau_f_treat

end subroutine read_parameters_all
