subroutine read_parameters_bytype
use mod_param
implicit none

!Define local variables:
real(mykind) :: help_real
real(mykind) :: beta_f_help(ntypes_f/2), beta_m_help(ntypes_m/4)
real(mykind) :: mu_m_nocirc(ntypes_m/4), mu_m_circ(ntypes_m/4)
real(mykind) :: xaxis_var_f(ntypes_f), xaxis_var_f_2(ntypes_f/2)
real(mykind) :: xaxis_var_m(ntypes_m), xaxis_var_m_2(ntypes_m/2), xaxis_var_m_4(ntypes_m/4)
integer :: ahelp
integer :: ii

!--------------------------------------------------------

!Nothing needs to be read from files here.
!The type specific parameters can all be determined from parameters_all stuff

if (do_misinformed==1) then
	
	!Females:
	A_f = A_global
	chi_f = 1.0
	
	mu_f(1:ntypes_f/2) = (1.0-frac_misinformed) * 1.0/real(ntypes_f/2)
	mu_f(ntypes_f/2+1:ntypes_f) = frac_misinformed * 1.0/real(ntypes_f/2)
	
	beta_f_help = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_f/2-1) ) , ii=1,ntypes_f/2 ) /)
	beta_f = [beta_f_help, beta_f_help]
	iota_f = iota_change * beta_f
	
	xaxis_var_f_2 = (/ ( (-al_range+(ii-1)*(2.0*al_range)/real(ntypes_f/2-1) ) , ii=1,ntypes_f/2 ) /)
	util_l_f(1:ntypes_f/2) = l_f + al1*xaxis_var_f_2 + al2*(xaxis_var_f_2**2) + al3*(xaxis_var_f_2**3)
	util_l_f(ntypes_f/2+1:ntypes_f) = l_f + al1*xaxis_var_f_2 + al2*(xaxis_var_f_2**2) + al3*(xaxis_var_f_2**3)
	
	!Males:
	if (do_circ==1) then
		A_m = A_global
		
		chi_m(1:ntypes_m/4) = 1.0
		chi_m(ntypes_m/4+1:ntypes_m/2) = chi_circ
		chi_m(ntypes_m/2+1:3*ntypes_m/4) = 1.0
		chi_m(3*ntypes_m/4+1:ntypes_m) = chi_circ
		
		mu_m_nocirc = 1.0/ real(ntypes_m/2) * (1.0-frac_circ)
		mu_m_circ = 1.0/ real(ntypes_m/2) * frac_circ
		mu_m = [(1-frac_misinformed)*mu_m_nocirc, (1-frac_misinformed)*mu_m_circ, frac_misinformed*mu_m_nocirc, frac_misinformed*mu_m_circ]
		
		help_real = sum(mu_m,1)
		mu_m = mu_m/help_real
		
		beta_m_help = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_m/4-1) ) , ii=1,ntypes_m/4 ) /)
		beta_m = [beta_m_help, beta_m_help, beta_m_help, beta_m_help]
		iota_m = iota_change * beta_m
		
		xaxis_var_m_4 = (/ ( (-al_range+(ii-1)*(2.0*al_range)/real(ntypes_m/4-1) ) , ii=1,ntypes_m/4 ) /)
		util_l_m(1:ntypes_m/4) = l_m + al1*xaxis_var_m_4 + al2*(xaxis_var_m_4**2) + al3*(xaxis_var_m_4**3)
		util_l_m(ntypes_m/4+1:ntypes_m/2) = l_m + al1*xaxis_var_m_4 + al2*(xaxis_var_m_4**2) + al3*(xaxis_var_m_4**3)
		util_l_m(ntypes_m/2+1:3*ntypes_m/4) = l_m + al1*xaxis_var_m_4 + al2*(xaxis_var_m_4**2) + al3*(xaxis_var_m_4**3)
		util_l_m(3*ntypes_m/4+1:ntypes_m) = l_m + al1*xaxis_var_m_4 + al2*(xaxis_var_m_4**2) + al3*(xaxis_var_m_4**3)
		
	else
		A_m = A_global
		chi_m = 1.0
		
		mu_m(1:ntypes_m/2) = (1.0-frac_misinformed) * 1.0/real(ntypes_m/2)
		mu_m(ntypes_m/2+1:ntypes_m) = frac_misinformed * 1.0/real(ntypes_m/2)
		
		beta_m(1:ntypes_m/2) = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_m/2-1) ) , ii=1,ntypes_m/2 ) /)
		beta_m(ntypes_m/2+1:ntypes_m) = beta_m(1:ntypes_m/2)
		iota_m = iota_change * beta_m
		
		xaxis_var_m_2 = (/ ( (-al_range+(ii-1)*(2.0*al_range)/real(ntypes_m/2-1) ) , ii=1,ntypes_m/2 ) /)
		util_l_m(1:ntypes_m/2) = l_m + al1*xaxis_var_m_2 + al2*(xaxis_var_m_2**2) + al3*(xaxis_var_m_2**3)
		util_l_m(ntypes_m/2+1:ntypes_m) = l_m + al1*xaxis_var_m_2 + al2*(xaxis_var_m_2**2) + al3*(xaxis_var_m_2**3)
	endif

else !no misinformed agents

	!Females:
	A_f = A_global
	chi_f = 1.0
	mu_f = 1.0/ real(ntypes_f)
	beta_f = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_f-1) ) , ii=1,ntypes_f ) /)
	iota_f = iota_change * beta_f
	xaxis_var_f = (/ ( (-al_range+(ii-1)*(2.0*al_range)/real(ntypes_f-1) ) , ii=1,ntypes_f ) /)
	util_l_f = l_f + al1*xaxis_var_f + al2*(xaxis_var_f**2) + al3*(xaxis_var_f**3)

	!Males:
	if (do_circ==1) then
		A_m = A_global
		chi_m(1:ntypes_m/2) = 1.0
		chi_m(ntypes_m/2+1:ntypes_m) = chi_circ
		mu_m(1:ntypes_m/2) = 1.0/ real(ntypes_m) * (1.0-frac_circ)
		mu_m(ntypes_m/2+1:ntypes_m) = 1.0/ real(ntypes_m) * frac_circ
		help_real = sum(mu_m,1)
		mu_m = mu_m/help_real
		beta_m(1:ntypes_m/2) = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_m/2-1) ) , ii=1,ntypes_m/2 ) /)
		beta_m(ntypes_m/2+1:ntypes_m) = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_m/2-1) ) , ii=1,ntypes_m/2 ) /)
		iota_m = iota_change * beta_m
		xaxis_var_m_2 = (/ ( (-al_range+(ii-1)*(2.0*al_range)/real(ntypes_m/2-1) ) , ii=1,ntypes_m/2 ) /)
		util_l_m(1:ntypes_m/2) = l_m + al1*xaxis_var_m_2 + al2*(xaxis_var_m_2**2) + al3*(xaxis_var_m_2**3)
		util_l_m(ntypes_m/2+1:ntypes_m) = l_m + al1*xaxis_var_m_2 + al2*(xaxis_var_m_2**2) + al3*(xaxis_var_m_2**3)
	else
		A_m = A_global
		chi_m = 1.0
		mu_m = 1.0/ real(ntypes_m)
		beta_m = (1.0-delta) * (/ ( (beta_max-(ii-1)*(beta_max-beta_min)/real(ntypes_m-1) ) , ii=1,ntypes_m ) /)
		iota_m = iota_change * beta_m
		xaxis_var_m = (/ ( (-al_range+(ii-1)*(2.0*al_range)/real(ntypes_m-1) ) , ii=1,ntypes_m ) /)
		util_l_m = l_m + al1*xaxis_var_m + al2*(xaxis_var_m**2) + al3*(xaxis_var_m**3)
	endif
	
endif


end subroutine read_parameters_bytype
