%This m-file prints the output for some desired model statistics.
expnumber

%Create number and flags for circumcision:
n_circ = 2;
i_nocirc = 1;
i_circ = 2;

%Create flags for each market:
i_protected = 1;
i_unprotected = 2;

%Create flags for each gender:
i_male = 1;
i_female = 2;

%PARAMETERS
% fprintf('\n')
% fprintf('PARAMETERS:\n')
% fprintf('income_m=%.2f, Transfers= %.2f %.2f %.2f\n', y_m, t_p, t_u, t_l)
% fprintf('CONSTANTS: alpha=%.3f, delta=%.3f, gammap_m=%.2f\n',alpha,delta,gammap_m)

%Consolidate distributions by type and age:
dist_S_all_m = sum(dist_S_m+dist_S_y_m,2);
dist_L_all_m = sum(dist_L_m+dist_L_y_m,2);
dist_A_all_m = sum(dist_A_m,2);
dist_S_all_f = sum(dist_S_f+dist_S_y_f,2);
dist_L_all_f = sum(dist_L_f+dist_L_y_f,2);
dist_A_all_f = sum(dist_A_f,2);

%Measures of slices of the population - by gender:
measure_m = sum(dist_S_all_m+dist_L_all_m+dist_A_all_m);
measure_f = sum(dist_S_all_f+dist_L_all_f+dist_A_all_f);

%Measures of slices of the population w/o symptoms - by age/gender:
measure_active_m_old   = sum(dist_S_m(:)+dist_L_m(:));
measure_active_m_young = sum(dist_S_y_m(:)+dist_L_y_m(:));
measure_active_m       = measure_active_m_old + measure_active_m_young;
measure_active_f_old   = sum(dist_S_f(:)+dist_L_f(:));
measure_active_f_young = sum(dist_S_y_f(:)+dist_L_y_f(:));
measure_active_f       = measure_active_f_old + measure_active_f_young;

%PARTICIPATION IN DIFFERENT MARKETS
%Males:
measure_p_m = sum((1.0-pi_l_m).*pi_p_m.*dist_S_m,2);
measure_u_m = sum((1.0-pi_l_m).*pi_u_m.*dist_S_m,2);
measure_a_m = sum((1.0-pi_l_m).*(1.0-pi_p_m-pi_u_m).*dist_S_m,2);
measure_l_m = sum(pi_l_m.*dist_S_m,2);
measure_p_y_m = sum((1.0-pi_l_y_m).*pi_p_y_m.*dist_S_y_m,2);
measure_u_y_m = sum((1.0-pi_l_y_m).*pi_u_y_m.*dist_S_y_m,2);
measure_a_y_m = sum((1.0-pi_l_y_m).*(1.0-pi_p_y_m-pi_u_y_m).*dist_S_y_m,2);
measure_l_y_m = sum(pi_l_y_m.*dist_S_y_m,2);
measure_p_all_m = measure_p_m + measure_p_y_m;
measure_u_all_m = measure_u_m + measure_u_y_m;
measure_l_all_m = measure_l_m + measure_l_y_m;
measure_a_all_m = measure_a_m + measure_a_y_m;

%Females:
measure_p_f = sum((1.0-pi_l_f).*pi_p_f.*dist_S_f,2);
measure_u_f = sum((1.0-pi_l_f).*pi_u_f.*dist_S_f,2);
measure_a_f = sum((1.0-pi_l_f).*(1.0-pi_p_f-pi_u_f).*dist_S_f,2);
measure_l_f = sum(pi_l_f.*dist_S_f,2);
measure_p_y_f = sum((1.0-pi_l_y_f).*pi_p_y_f.*dist_S_y_f,2);
measure_u_y_f = sum((1.0-pi_l_y_f).*pi_u_y_f.*dist_S_y_f,2);
measure_a_y_f = sum((1.0-pi_l_y_f).*(1.0-pi_p_y_f-pi_u_y_f).*dist_S_y_f,2);
measure_l_y_f = sum(pi_l_y_f.*dist_S_y_f,2);
measure_p_all_f = measure_p_f + measure_p_y_f;
measure_u_all_f = measure_u_f + measure_u_y_f;
measure_l_all_f = measure_l_f + measure_l_y_f;
measure_a_all_f = measure_a_f + measure_a_y_f;

%PREVALENCE RATE IN SOCIETY
%Overall - males
percentage_aids_m = sum(dist_S_all_m(2:3)+dist_L_all_m(2:3)+dist_A_all_m(2:3)) / measure_m;
%Overall - females
percentage_aids_f = sum(dist_S_all_f(2:3)+dist_L_all_f(2:3)+dist_A_all_f(2:3)) / measure_f;
%Overall - society
percentage_aids = (measure_m*percentage_aids_m+measure_f*percentage_aids_f) / (measure_m+measure_f);

%fraction of singles in society (measure in the beginning of the period):
fraction_single_m = sum(dist_S_all_m+dist_A_all_m) / sum(dist_S_all_m+dist_L_all_m+dist_A_all_m);
fraction_single_f = sum(dist_S_all_f+dist_A_all_f) / sum(dist_S_all_f+dist_L_all_f+dist_A_all_f);
fraction_single = sum(dist_S_all_m+dist_A_all_m+dist_S_all_f+dist_A_all_f) / sum(dist_S_all_m+dist_L_all_m+dist_A_all_m+dist_S_all_f+dist_L_all_f+dist_A_all_f);

%TYPE STRUCTURE
% fprintf('\n')
% disp('---------------JOY FOR DIFFERENT RELATIONS---------------------------------')
% fprintf('  MALES: unprotected sex = %.3f and long term relation = %.3f \n',u_m,l_m)
% fprintf('FEMALES: unprotected sex = %.3f and long term relation = %.3f \n',u_f,l_f)
% fprintf('\n')

%TYPE STRUCTURE
% disp('--Percent of singles relative to steady-state size of the group--')
% disp('-- at the beginning of the period (marriage market) --')
% fprintf('  MALES:  %.4f  \n',fraction_single_m)
% fprintf('FEMALES:  %.4f  \n',fraction_single_f)
% fprintf('SOCIETY:  %.4f  \n \n',fraction_single)

% disp('---------------Percent of singles that enter long-term market each period---------------------------------')
ratio_l_y_m = zeros(ntypes_m,1);
ratio_l_m = zeros(ntypes_m,1);
for ii=1:ntypes_m
    ratio_l_y_m(ii) = sum(pi_l_y_m(:,ii).*dist_S_y_m(:,ii)) / sum(dist_S_y_m(:,ii));
%     fprintf('  MALE TYPE %.0f (young):   long term relation = %.4f \n',ii,ratio_l_y_m(ii))
    ratio_l_m(ii) = sum(pi_l_m(:,ii).*dist_S_m(:,ii)) / sum(dist_S_m(:,ii));
%     fprintf('  MALE TYPE %.0f  (old) :   long term relation = %.4f \n',ii,ratio_l_m(ii))
end
ratio_l_y_f = zeros(ntypes_f,1);
ratio_l_f = zeros(ntypes_f,1);
for ii=1:ntypes_f
    ratio_l_y_f(ii) = sum(pi_l_y_f(:,ii).*dist_S_y_f(:,ii)) / sum(dist_S_y_f(:,ii));
%     fprintf('FEMALE TYPE %.0f (young):   long term relation = %.4f \n',ii,ratio_l_y_f(ii))
    ratio_l_f(ii) = sum(pi_l_f(:,ii).*dist_S_f(:,ii)) / sum(dist_S_f(:,ii));
%     fprintf('FEMALE TYPE %.0f  (old) :   long term relation = %.4f \n',ii,ratio_l_f(ii))
end
% fprintf('\n')

% disp('--Percent of singles that enter short-term market each period (conditional on not matched in long-term)--')
ratio_u_m = zeros(ntypes_m,1);
ratio_p_m = zeros(ntypes_m,1);
ratio_n_m = zeros(ntypes_m,1);
ratio_u_y_m = zeros(ntypes_m,1);
ratio_p_y_m = zeros(ntypes_m,1);
ratio_n_y_m = zeros(ntypes_m,1);
for ii=1:ntypes_m
    ratio_u_m(ii) = sum((1-pi_l_m(:,ii)).*pi_u_m(:,ii).*dist_S_m(:,ii)) / sum((1-pi_l_m(:,ii)).*dist_S_m(:,ii));
    ratio_p_m(ii) = sum((1-pi_l_m(:,ii)).*pi_p_m(:,ii).*dist_S_m(:,ii)) / sum((1-pi_l_m(:,ii)).*dist_S_m(:,ii));
    ratio_n_m(ii) = sum((1-pi_l_m(:,ii)).*(1-pi_p_m(:,ii)-pi_u_m(:,ii)).*dist_S_m(:,ii)) / sum((1-pi_l_m(:,ii)).*dist_S_m(:,ii));
    ratio_u_y_m(ii) = sum((1-pi_l_y_m(:,ii)).*pi_u_y_m(:,ii).*dist_S_y_m(:,ii)) / sum((1-pi_l_y_m(:,ii)).*dist_S_y_m(:,ii));
    ratio_p_y_m(ii) = sum((1-pi_l_y_m(:,ii)).*pi_p_y_m(:,ii).*dist_S_y_m(:,ii)) / sum((1-pi_l_y_m(:,ii)).*dist_S_y_m(:,ii));
    ratio_n_y_m(ii) = sum((1-pi_l_y_m(:,ii)).*(1-pi_p_y_m(:,ii)-pi_u_y_m(:,ii)).*dist_S_y_m(:,ii)) / sum((1-pi_l_y_m(:,ii)).*dist_S_y_m(:,ii));
%     fprintf('  MALE TYPE %.0f (young): unprotected = %.4f, protected = %.4f, no short term =%.4f \n',ii,ratio_u_y_m(ii), ratio_p_y_m(ii), ratio_n_y_m(ii))
%     fprintf('  MALE TYPE %.0f  (old) : unprotected = %.4f, protected = %.4f, no short term =%.4f \n',ii,ratio_u_m(ii), ratio_p_m(ii), ratio_n_m(ii))
end
ratio_u_f = zeros(ntypes_f,1);
ratio_p_f = zeros(ntypes_f,1);
ratio_n_f = zeros(ntypes_f,1);
ratio_u_y_f = zeros(ntypes_f,1);
ratio_p_y_f = zeros(ntypes_f,1);
ratio_n_y_f = zeros(ntypes_f,1);
for ii=1:ntypes_f
    ratio_u_f(ii) = sum((1-pi_l_f(:,ii)).*pi_u_f(:,ii).*dist_S_f(:,ii)) / sum((1-pi_l_f(:,ii)).*dist_S_f(:,ii));
    ratio_p_f(ii) = sum((1-pi_l_f(:,ii)).*pi_p_f(:,ii).*dist_S_f(:,ii)) / sum((1-pi_l_f(:,ii)).*dist_S_f(:,ii));
    ratio_n_f(ii) = sum((1-pi_l_f(:,ii)).*(1-pi_p_f(:,ii)-pi_u_f(:,ii)).*dist_S_f(:,ii)) / sum((1-pi_l_f(:,ii)).*dist_S_f(:,ii));
    ratio_u_y_f(ii) = sum((1-pi_l_y_f(:,ii)).*pi_u_y_f(:,ii).*dist_S_y_f(:,ii)) / sum((1-pi_l_y_f(:,ii)).*dist_S_y_f(:,ii));
    ratio_p_y_f(ii) = sum((1-pi_l_y_f(:,ii)).*pi_p_y_f(:,ii).*dist_S_y_f(:,ii)) / sum((1-pi_l_y_f(:,ii)).*dist_S_y_f(:,ii));
    ratio_n_y_f(ii) = sum((1-pi_l_y_f(:,ii)).*(1-pi_p_y_f(:,ii)-pi_u_y_f(:,ii)).*dist_S_y_f(:,ii)) / sum((1-pi_l_y_f(:,ii)).*dist_S_y_f(:,ii));
%     fprintf('FEMALE TYPE %.0f (young): unprotected = %.4f, protected = %.4f, no short term =%.4f \n',ii,ratio_u_y_f(ii), ratio_p_y_f(ii), ratio_n_y_f(ii))
%     fprintf('FEMALE TYPE %.0f  (old) : unprotected = %.4f, protected = %.4f, no short term =%.4f \n',ii,ratio_u_f(ii), ratio_p_f(ii), ratio_n_f(ii))
end
% fprintf('\n')

% disp('----What are the healthy guys (phi=1) doing (search effort)?----')
% fprintf('                 Long term market    Protected Market     Unprotected Market       Abstinence\n')
for ii=1:ntypes_m
%     fprintf('  Male type %.0f (young)   %.4f              %.4f                %.4f               %.4f\n',ii,pi_l_y_m(1,ii),pi_p_y_m(1,ii),pi_u_y_m(1,ii),1-pi_p_y_m(1,ii)-pi_u_y_m(1,ii))
%     fprintf('  Male type %.0f (old)     %.4f              %.4f                %.4f               %.4f\n',ii,pi_l_m(1,ii),pi_p_m(1,ii),pi_u_m(1,ii),1-pi_p_m(1,ii)-pi_u_m(1,ii))
end
for ii=1:ntypes_f
%     fprintf('Female type %.0f (young)   %.4f              %.4f                %.4f               %.4f\n',ii,pi_l_y_f(1,ii),pi_p_y_f(1,ii),pi_u_y_f(1,ii),1-pi_p_y_f(1,ii)-pi_u_y_f(1,ii))
%     fprintf('Female type %.0f (old)     %.4f              %.4f                %.4f               %.4f\n',ii,pi_l_f(1,ii),pi_p_f(1,ii),pi_u_f(1,ii),1-pi_p_f(1,ii)-pi_u_f(1,ii))
end

% fprintf('\n')

%PREVALENCE RATES
% fprintf('      TYPE        AVERAGE NON-PREVALENCE RATE \n\n')
% fprintf('male - protected:         %.4f     \n',prev1(1))
% fprintf('male - unprotected:       %.4f     \n',prev1(2))
% fprintf('male - no sex:            %.4f     \n',prev1(7))
% fprintf('male - long term:         %.4f     \n',prev1(3))
% fprintf('female - protected:       %.4f     \n',prev1(4))
% fprintf('female - unprotected:     %.4f     \n',prev1(5))
% fprintf('female - no sex:          %.4f     \n',prev1(8))
% fprintf('female - long term:       %.4f     \n',prev1(6))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%      MOMENTS    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%
%%% MOMENT 1:

% fprintf('\n\n')
% disp('----------- MOMENT 1 ----------------')
% disp('Fraction with HIV (all/by gender)')
% disp('-------------------------------------')
% 
% fprintf(' Males                %.4f\n',percentage_aids_m)
% fprintf(' Females              %.4f\n',percentage_aids_f)
% fprintf(' Society              %.4f\n',percentage_aids)
% 
% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%
%%% MOMENT 2:

% fprintf('\n\n')
% disp('----------- MOMENT 2 ----------------')
% disp('Conditional on having sex last period,')
% disp('probability that it was short term')
% disp('-------------------------------------')
% disp('')

%Males:
prob_s_m = zeros(ntypes_m,1);
prob_s_y_m = zeros(ntypes_m,1);
for ii=1:ntypes_m
    prob_s_y_m(ii) = sum((1-pi_l_y_m(:,ii)).*(pi_p_y_m(:,ii)+pi_u_y_m(:,ii)).*dist_S_y_m(:,ii)) / ...
        sum(dist_L_y_m(:,ii)+pi_l_y_m(:,ii).*dist_S_y_m(:,ii)+(1-pi_l_y_m(:,ii)).*(pi_p_y_m(:,ii)+pi_u_y_m(:,ii)).*dist_S_y_m(:,ii));
    prob_s_m(ii) = sum((1-pi_l_m(:,ii)).*(pi_p_m(:,ii)+pi_u_m(:,ii)).*dist_S_m(:,ii)) / ...
        sum(dist_L_m(:,ii)+pi_l_m(:,ii).*dist_S_m(:,ii)+(1-pi_l_m(:,ii)).*(pi_p_m(:,ii)+pi_u_m(:,ii)).*dist_S_m(:,ii));
%     fprintf('Male type %.0f (young)    %.4f \n',ii,prob_s_y_m(ii))
%     fprintf('Male type %.0f (old)      %.4f \n',ii,prob_s_m(ii))
end
prob_s_all_m = sum(measure_p_all_m+measure_u_all_m) / sum(measure_p_all_m+measure_u_all_m+measure_l_all_m+dist_L_all_m);
% fprintf('Males                  %.4f \n',prob_s_all_m)

%Females:
prob_s_f = zeros(ntypes_f,1);
prob_s_y_f = zeros(ntypes_f,1);
for ii=1:ntypes_f
    prob_s_y_f(ii) = sum((1-pi_l_y_f(:,ii)).*(pi_p_y_f(:,ii)+pi_u_y_f(:,ii)).*dist_S_y_f(:,ii)) / ...
        sum(dist_L_y_f(:,ii)+pi_l_y_f(:,ii).*dist_S_y_f(:,ii)+(1-pi_l_y_f(:,ii)).*(pi_p_y_f(:,ii)+pi_u_y_f(:,ii)).*dist_S_y_f(:,ii));
    prob_s_f(ii) = sum((1-pi_l_f(:,ii)).*(pi_p_f(:,ii)+pi_u_f(:,ii)).*dist_S_f(:,ii)) / ...
        sum(dist_L_f(:,ii)+pi_l_f(:,ii).*dist_S_f(:,ii)+(1-pi_l_f(:,ii)).*(pi_p_f(:,ii)+pi_u_f(:,ii)).*dist_S_f(:,ii));
%     fprintf('Female type %.0f (young)  %.4f \n',ii,prob_s_y_f(ii))
%     fprintf('Female type %.0f (old)    %.4f \n',ii,prob_s_f(ii))
end
prob_s_all_f = sum(measure_p_all_f+measure_u_all_f) / sum(measure_p_all_f+measure_u_all_f+measure_l_all_f+dist_L_all_f);
% fprintf('Females                %.4f \n',prob_s_all_f)

%Everyone:
prob_s = sum(measure_p_all_m+measure_u_all_m+measure_p_all_f+measure_u_all_f) / ...
    sum(measure_p_all_m+measure_u_all_m+measure_l_all_m+dist_L_all_m+measure_p_all_f+measure_u_all_f+measure_l_all_f+dist_L_all_f);
% fprintf('Society                %.4f \n',prob_s)

% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%
%%% MOMENT 3:

% fprintf('\n\n')
% disp('----------- MOMENT 3 ----------------')
% disp('Conditional on having sex in the short-term')
% disp('market, what fraction used condom')
% disp('-------------------------------------')

%Males:
prob_condom_m = zeros(ntypes_m,1);
prob_condom_y_m = zeros(ntypes_m,1);
for ii=1:ntypes_m
    prob_condom_y_m(ii) = sum((1-pi_l_y_m(:,ii)).*pi_p_y_m(:,ii).*dist_S_y_m(:,ii)) / sum(measure_p_y_m+measure_u_y_m);
    prob_condom_m(ii) = sum((1-pi_l_m(:,ii)).*pi_p_m(:,ii).*dist_S_m(:,ii)) / sum(measure_p_m+measure_u_m);
%     fprintf('Male type %.0f (young)    %.4f \n',ii,prob_condom_y_m(ii))
%     fprintf('Male type %.0f (old)      %.4f \n',ii,prob_condom_m(ii))
end
prob_condom_all_m = sum(measure_p_all_m) / sum(measure_p_all_m+measure_u_all_m);
% fprintf('Males                  %.4f \n',prob_condom_all_m)

%Females:
prob_condom_f = zeros(ntypes_f,1);
prob_condom_y_f = zeros(ntypes_f,1);
for ii=1:ntypes_f
    prob_condom_y_f(ii) = sum((1-pi_l_y_f(:,ii)).*pi_p_y_f(:,ii).*dist_S_y_f(:,ii)) / sum(measure_p_y_f+measure_u_y_f);
    prob_condom_f(ii) = sum((1-pi_l_f(:,ii)).*pi_p_f(:,ii).*dist_S_f(:,ii)) / sum(measure_p_f+measure_u_f);
%     fprintf('Female type %.0f (young)  %.4f \n',ii,prob_condom_y_f(ii))
%     fprintf('Female type %.0f (old)    %.4f \n',ii,prob_condom_f(ii))
end
prob_condom_all_f = sum(measure_p_all_f) / sum(measure_p_all_f+measure_u_all_f);
% fprintf('Females                %.4f \n',prob_condom_all_f)

%Everyone:
prob_condom = sum(measure_p_all_m+measure_p_all_f) / sum(measure_p_all_m+measure_p_all_f+measure_u_all_m+measure_u_all_f);
% fprintf('Society                %.4f \n',prob_condom)

% disp('--------------------------------------------------------------------------')
% disp('')


%%%%%%%%%%%%%%%%%%
%%% MOMENT 4:

% fprintf('\n\n')
% disp('----------- MOMENT 4 ----------------')
% disp('Conditional on being single, probability')
% disp('of having sex in the short-term market')
% disp('-------------------------------------')

%Males:
prob_shortsex_y_m = zeros(ntypes_m,1);
prob_shortsex_m = zeros(ntypes_m,1);
for ii=1:ntypes_m
    prob_shortsex_y_m(ii) = sum((1-pi_l_y_m(:,ii)).*(pi_p_y_m(:,ii)+pi_u_y_m(:,ii)).*dist_S_y_m(:,ii)) / ...
        sum((1-pi_l_y_m(:,ii)).*dist_S_y_m(:,ii));
    prob_shortsex_m(ii) = sum((1-pi_l_m(:,ii)).*(pi_p_m(:,ii)+pi_u_m(:,ii)).*dist_S_m(:,ii)) / ...
        sum((1-pi_l_m(:,ii)).*dist_S_m(:,ii));
%     fprintf('Male type %.0f (young)    %.4f \n',ii,prob_shortsex_y_m(ii))
%     fprintf('Male type %.0f (old)      %.4f \n',ii,prob_shortsex_m(ii))
end
prob_shortsex_all_m = sum(measure_p_all_m+measure_u_all_m) / sum(measure_p_all_m+measure_u_all_m+measure_a_all_m);
% fprintf('Males                  %.4f \n',prob_shortsex_all_m)

%Females:
prob_shortsex_y_f = zeros(ntypes_f,1);
prob_shortsex_f = zeros(ntypes_f,1);
for ii=1:ntypes_f
    prob_shortsex_y_f(ii) = sum((1-pi_l_y_f(:,ii)).*(pi_p_y_f(:,ii)+pi_u_y_f(:,ii)).*dist_S_y_f(:,ii)) / ...
        sum((1-pi_l_y_f(:,ii)).*dist_S_y_f(:,ii));
    prob_shortsex_f(ii) = sum((1-pi_l_f(:,ii)).*(pi_p_f(:,ii)+pi_u_f(:,ii)).*dist_S_f(:,ii)) / ...
        sum((1-pi_l_f(:,ii)).*dist_S_f(:,ii));
%     fprintf('Female type %.0f (young)  %.4f \n',ii,prob_shortsex_y_f(ii))
%     fprintf('Female type %.0f (old)    %.4f \n',ii,prob_shortsex_f(ii))
end
prob_shortsex_all_f = sum(measure_p_all_f+measure_u_all_f) / sum(measure_p_all_f+measure_u_all_f+measure_a_all_f);
% fprintf('Females                %.4f \n',prob_shortsex_all_f)

%Everyone:
prob_shortsex = sum(measure_p_all_m+measure_u_all_m+measure_p_all_f+measure_u_all_f) / ...
    sum(measure_p_all_m+measure_u_all_m+measure_a_all_m+measure_p_all_f+measure_u_all_f+measure_a_all_f);
% fprintf('Society                %.4f \n',prob_shortsex)


% disp('--------------------------------------------------------------------------')
% disp('')


%%%%%%%%%%%%%%%%%%
%%% MOMENT 4a:

% fprintf('\n\n')
% disp('----------- MOMENT 4a ---------------')
% disp('Fraction of singles that had sex last year')
% disp('(i.e. during the last 4 model periods')
% disp('-------------------------------------')

%Create vector for alpha's:
alpha_vec = zeros(n_status,1);
alpha_vec(i_healthy) = 0;
alpha_vec(i_sick) = alpha;
alpha_vec(i_treated) = alpha_treat;

%MALES

%Create distribution across beliefs for people that were just born
%(This is trivially degenerate since they're all healthy)
dist_birth_m = zeros(n_status,ntypes_m);
dist_birth_y_m = zeros(n_status,ntypes_m);
for ii=1:ntypes_m
    dist_birth_m(i_healthy,ii) = eta*mu_m(ii);
    dist_birth_y_m(i_healthy,ii) = (1-eta)*mu_m(ii);
end

%Create some useful distributions:
dist_single_pr = zeros(n_status,ntypes_m);
dist_single_y_pr = zeros(n_status,ntypes_m);
dist_single_prpr = zeros(n_status,ntypes_m);
dist_single_y_prpr = zeros(n_status,ntypes_m);
dist_temp = zeros(n_status,ntypes_m);
dist_temp_y = zeros(n_status,ntypes_m);
dist_symptoms_pr = zeros(n_status,ntypes_m);
dist_temp_symptoms = zeros(n_status,ntypes_m);

%Create distributions that will hold the results:
dist_single_abst_m = zeros(n_status,ntypes_m,4); %The last 4 is for four quarters in a year
dist_single_abst_y_m = zeros(n_status,ntypes_m,4); %The last 4 is for four quarters in a year
dist_symptoms_abst_m = zeros(n_status,ntypes_m,4); %The last 4 is for four quarters in a year

%Apply abstinence mapping for three periods for the newborns:
dist_apply = dist_birth_m;
dist_apply_y = dist_birth_y_m;
dist_symptoms_apply = zeros(n_status,ntypes_m); %nobody is born with symptoms
for tt=1:3
    for ii=1:ntypes_m
        %those without symptoms:
        dist_single_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_m(:,ii)).*(1-pi_p_m(:,ii)-pi_u_m(:,ii)).*dist_apply(:,ii);
        dist_single_y_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_y_m(:,ii)).*(1-pi_p_y_m(:,ii)-pi_u_y_m(:,ii)).*dist_apply_y(:,ii);
        dist_single_prpr(:,ii) = dist_single_pr(:,ii) + eta*dist_single_y_pr(:,ii);
        dist_single_y_prpr(:,ii) = (1-eta)*dist_single_y_pr(:,ii);
        dist_single_abst_m(i_healthy,ii,tt) = dist_single_prpr(i_healthy,ii);
        dist_single_abst_m(i_sick,ii,tt) = dist_single_prpr(i_sick,ii)*(1-q);
        dist_single_abst_m(i_treated,ii,tt) = dist_single_prpr(i_sick,ii)*q + dist_single_prpr(i_treated,ii);
        dist_single_abst_y_m(i_healthy,ii,tt) = dist_single_y_prpr(i_healthy,ii);
        dist_single_abst_y_m(i_sick,ii,tt) = dist_single_y_prpr(i_sick,ii)*(1-q);
        dist_single_abst_y_m(i_treated,ii,tt) = dist_single_y_prpr(i_sick,ii)*q + dist_single_y_prpr(i_treated,ii);
        %those with symptoms:
        dist_symptoms_pr(:,ii) = (1-delta).*( (1-delta2).*dist_symptoms_apply(:,ii) + dist_apply(:,ii).*alpha_vec.*(1-pi_l_m(:,ii)).*(1-pi_p_m(:,ii)-pi_u_m(:,ii)) + dist_apply_y(:,ii).*alpha_vec.*(1-pi_l_y_m(:,ii)).*(1-pi_p_y_m(:,ii)-pi_u_y_m(:,ii)) );
        dist_symptoms_abst_m(i_healthy,ii,tt) = 0;
        dist_symptoms_abst_m(i_sick,ii,tt) = dist_symptoms_pr(i_sick,ii)*(1-q);
        dist_symptoms_abst_m(i_treated,ii,tt) = dist_symptoms_pr(i_sick,ii)*q + dist_symptoms_pr(i_treated,ii);
    end
    dist_apply = dist_single_abst_m(:,:,tt);
    dist_apply_y = dist_single_abst_y_m(:,:,tt);
    dist_symptoms_apply = dist_symptoms_abst_m(:,:,tt);
end

%Apply abstinence mapping for four periods for the people that were around:
dist_apply = dist_S_m;
dist_apply_y = dist_S_y_m;
dist_symptoms_apply = dist_A_m;
for tt=1:4
    for ii=1:ntypes_m
        %those without symptoms:
        dist_single_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_m(:,ii)).*(1-pi_p_m(:,ii)-pi_u_m(:,ii)).*dist_apply(:,ii);
        dist_single_y_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_y_m(:,ii)).*(1-pi_p_y_m(:,ii)-pi_u_y_m(:,ii)).*dist_apply_y(:,ii);
        dist_single_prpr(:,ii) = dist_single_pr(:,ii) + eta*dist_single_y_pr(:,ii);
        dist_single_y_prpr(:,ii) = (1-eta)*dist_single_y_pr(:,ii);
        dist_temp(i_healthy,ii) = dist_single_prpr(i_healthy,ii);
        dist_temp(i_sick,ii) = dist_single_prpr(i_sick,ii)*(1-q);
        dist_temp(i_treated,ii) = dist_single_prpr(i_sick,ii)*q + dist_single_prpr(i_treated,ii);
        dist_temp_y(i_healthy,ii) = dist_single_y_prpr(i_healthy,ii);
        dist_temp_y(i_sick,ii) = dist_single_y_prpr(i_sick,ii)*(1-q);
        dist_temp_y(i_treated,ii) = dist_single_y_prpr(i_sick,ii)*q + dist_single_y_prpr(i_treated,ii);
        %those with symptoms:
        dist_symptoms_pr(:,ii) = (1-delta).*( (1-delta2).*dist_symptoms_apply(:,ii) + dist_apply(:,ii).*alpha_vec.*(1-pi_l_m(:,ii)).*(1-pi_p_m(:,ii)-pi_u_m(:,ii)) + dist_apply_y(:,ii).*alpha_vec.*(1-pi_l_y_m(:,ii)).*(1-pi_p_y_m(:,ii)-pi_u_y_m(:,ii)) );
        dist_temp_symptoms(i_healthy,ii) = 0;
        dist_temp_symptoms(i_sick,ii) = dist_symptoms_pr(i_sick,ii)*(1-q);
        dist_temp_symptoms(i_treated,ii) = dist_symptoms_pr(i_sick,ii)*q + dist_symptoms_pr(i_treated,ii);
    end
    dist_apply = dist_temp;
    dist_apply_y = dist_temp_y;
    dist_symptoms_apply = dist_temp_symptoms;
end
dist_single_abst_m(:,:,4) = dist_temp;
dist_single_abst_y_m(:,:,4) = dist_temp_y;
dist_symptoms_abst_m(:,:,4) = dist_temp_symptoms;

%Add young and old agents into one array:
dist_birth_all_m = dist_birth_m + dist_birth_y_m;
dist_single_abst_all_m = dist_single_abst_m + dist_single_abst_y_m;
dist_symptoms_abst_all_m = dist_symptoms_abst_m;

%Put all periods (last 4 quarters) together, plus newborns: 
prob_shortsex2_type_m = zeros(ntypes_m);
for ii=1:ntypes_m
    ahelp_numerator = sum(sum( dist_single_abst_all_m(:,ii,:)+dist_symptoms_abst_all_m(:,ii,:) )) + sum(dist_birth_all_m(:,ii)) ;
    ahelp_denominator = sum(dist_S_m(:,ii) + dist_S_y_m(:,ii) + dist_A_m(:,ii));
    ahelp = ahelp_numerator / ahelp_denominator;
    prob_shortsex2_type_m(ii) = 1 - ahelp;
%     fprintf('Male type %.0f      %.4f \n',ii,prob_shortsex2_type_m(ii))
end
ahelp_numerator_m = sum(dist_single_abst_all_m(:)) + sum(dist_symptoms_abst_all_m(:)) + sum(dist_birth_all_m(:));
ahelp_denominator_m = sum(dist_S_m(:)) + sum(dist_S_y_m(:)) + sum(dist_A_m(:));
ahelp_m = ahelp_numerator_m / ahelp_denominator_m;
prob_shortsex2_m = 1 - ahelp_m;
% fprintf('Males            %.4f \n',prob_shortsex2_m)

%FEMALES

%Create distribution across beliefs for people that were just born
%(This is trivially degenerate since they're all healthy)
dist_birth_f = zeros(n_status,ntypes_f);
dist_birth_y_f = zeros(n_status,ntypes_f);
for ii=1:ntypes_f
    dist_birth_f(i_healthy,ii) = eta*mu_f(ii);
    dist_birth_y_f(i_healthy,ii) = (1-eta)*mu_f(ii);
end

%Create some useful distributions:
dist_single_pr = zeros(n_status,ntypes_f);
dist_single_y_pr = zeros(n_status,ntypes_f);
dist_single_prpr = zeros(n_status,ntypes_f);
dist_single_y_prpr = zeros(n_status,ntypes_f);
dist_temp = zeros(n_status,ntypes_f);
dist_temp_y = zeros(n_status,ntypes_f);
dist_symptoms_pr = zeros(n_status,ntypes_f);
dist_temp_symptoms = zeros(n_status,ntypes_f);

%Create distributions that will hold the results:
dist_single_abst_f = zeros(n_status,ntypes_f,4); %The last 4 is for four quarters in a year
dist_single_abst_y_f = zeros(n_status,ntypes_f,4); %The last 4 is for four quarters in a year
dist_symptoms_abst_f = zeros(n_status,ntypes_f,4); %The last 4 is for four quarters in a year

%Apply abstinence mapping for three periods for the newborns:
dist_apply = dist_birth_f;
dist_apply_y = dist_birth_y_f;
dist_symptoms_apply = zeros(n_status,ntypes_f); %nobody is born with symptoms
for tt=1:3
    for ii=1:ntypes_f
        %those without symptoms:
        dist_single_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_f(:,ii)).*(1-pi_p_f(:,ii)-pi_u_f(:,ii)).*dist_apply(:,ii);
        dist_single_y_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_y_f(:,ii)).*(1-pi_p_y_f(:,ii)-pi_u_y_f(:,ii)).*dist_apply_y(:,ii);
        dist_single_prpr(:,ii) = dist_single_pr(:,ii) + eta*dist_single_y_pr(:,ii);
        dist_single_y_prpr(:,ii) = (1-eta)*dist_single_y_pr(:,ii);
        dist_single_abst_f(i_healthy,ii,tt) = dist_single_prpr(i_healthy,ii);
        dist_single_abst_f(i_sick,ii,tt) = dist_single_prpr(i_sick,ii)*(1-q);
        dist_single_abst_f(i_treated,ii,tt) = dist_single_prpr(i_sick,ii)*q + dist_single_prpr(i_treated,ii);
        dist_single_abst_y_f(i_healthy,ii,tt) = dist_single_y_prpr(i_healthy,ii);
        dist_single_abst_y_f(i_sick,ii,tt) = dist_single_y_prpr(i_sick,ii)*(1-q);
        dist_single_abst_y_f(i_treated,ii,tt) = dist_single_y_prpr(i_sick,ii)*q + dist_single_y_prpr(i_treated,ii);
        %those with symptoms:
        dist_symptoms_pr(:,ii) = (1-delta).*( (1-delta2).*dist_symptoms_apply(:,ii) + dist_apply(:,ii).*alpha_vec.*(1-pi_l_f(:,ii)).*(1-pi_p_f(:,ii)-pi_u_f(:,ii)) + dist_apply_y(:,ii).*alpha_vec.*(1-pi_l_y_f(:,ii)).*(1-pi_p_y_f(:,ii)-pi_u_y_f(:,ii)) );
        dist_symptoms_abst_f(i_healthy,ii,tt) = 0;
        dist_symptoms_abst_f(i_sick,ii,tt) = dist_symptoms_pr(i_sick,ii)*(1-q);
        dist_symptoms_abst_f(i_treated,ii,tt) = dist_symptoms_pr(i_sick,ii)*q + dist_symptoms_pr(i_treated,ii);
    end
    dist_apply = dist_single_abst_f(:,:,tt);
    dist_apply_y = dist_single_abst_y_f(:,:,tt);
    dist_symptoms_apply = dist_symptoms_abst_f(:,:,tt);
end

%Apply abstinence mapping for four periods for the people that were around:
dist_apply = dist_S_f;
dist_apply_y = dist_S_y_f;
dist_symptoms_apply = dist_A_f;
for tt=1:4
    for ii=1:ntypes_f
        %those without symptoms:
        dist_single_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_f(:,ii)).*(1-pi_p_f(:,ii)-pi_u_f(:,ii)).*dist_apply(:,ii);
        dist_single_y_pr(:,ii) = (1-delta).*(1-alpha_vec).*(1-pi_l_y_f(:,ii)).*(1-pi_p_y_f(:,ii)-pi_u_y_f(:,ii)).*dist_apply_y(:,ii);
        dist_single_prpr(:,ii) = dist_single_pr(:,ii) + eta*dist_single_y_pr(:,ii);
        dist_single_y_prpr(:,ii) = (1-eta)*dist_single_y_pr(:,ii);
        dist_temp(i_healthy,ii) = dist_single_prpr(i_healthy,ii);
        dist_temp(i_sick,ii) = dist_single_prpr(i_sick,ii)*(1-q);
        dist_temp(i_treated,ii) = dist_single_prpr(i_sick,ii)*q + dist_single_prpr(i_treated,ii);
        dist_temp_y(i_healthy,ii) = dist_single_y_prpr(i_healthy,ii);
        dist_temp_y(i_sick,ii) = dist_single_y_prpr(i_sick,ii)*(1-q);
        dist_temp_y(i_treated,ii) = dist_single_y_prpr(i_sick,ii)*q + dist_single_y_prpr(i_treated,ii);
        %those with symptoms:
        dist_symptoms_pr(:,ii) = (1-delta).*( (1-delta2).*dist_symptoms_apply(:,ii) + dist_apply(:,ii).*alpha_vec.*(1-pi_l_f(:,ii)).*(1-pi_p_f(:,ii)-pi_u_f(:,ii)) + dist_apply_y(:,ii).*alpha_vec.*(1-pi_l_y_f(:,ii)).*(1-pi_p_y_f(:,ii)-pi_u_y_f(:,ii)) );
        dist_temp_symptoms(i_healthy,ii) = 0;
        dist_temp_symptoms(i_sick,ii) = dist_symptoms_pr(i_sick,ii)*(1-q);
        dist_temp_symptoms(i_treated,ii) = dist_symptoms_pr(i_sick,ii)*q + dist_symptoms_pr(i_treated,ii);
    end
    dist_apply = dist_temp;
    dist_apply_y = dist_temp_y;
    dist_symptoms_apply = dist_temp_symptoms;
end
dist_single_abst_f(:,:,4) = dist_temp;
dist_single_abst_y_f(:,:,4) = dist_temp_y;
dist_symptoms_abst_f(:,:,4) = dist_temp_symptoms;

%Add young and old agents into one array:
dist_birth_all_f = dist_birth_f + dist_birth_y_f;
dist_single_abst_all_f = dist_single_abst_f + dist_single_abst_y_f;
dist_symptoms_abst_all_f = dist_symptoms_abst_f;

%Put all periods (last 4 quarters) together, plus newborns: 
prob_shortsex2_type_f = zeros(ntypes_f);
for ii=1:ntypes_f
    ahelp_numerator = sum(sum( dist_single_abst_all_f(:,ii,:)+dist_symptoms_abst_all_f(:,ii,:) )) + sum(dist_birth_all_f(:,ii)) ;
    ahelp_denominator = sum(dist_S_f(:,ii) + dist_S_y_f(:,ii) + dist_A_f(:,ii));
    ahelp = ahelp_numerator / ahelp_denominator;
    prob_shortsex2_type_f(ii) = 1 - ahelp;
%     fprintf('Female type %.0f    %.4f \n',ii,prob_shortsex2_type_f(ii))
end
ahelp_numerator_f = sum(dist_single_abst_all_f(:)) + sum(dist_symptoms_abst_all_f(:)) + sum(dist_birth_all_f(:));
ahelp_denominator_f = sum(dist_S_f(:)) + sum(dist_S_y_f(:)) + sum(dist_A_f(:));
ahelp_f = ahelp_numerator_f / ahelp_denominator_f;
prob_shortsex2_f = 1 - ahelp_f;
% fprintf('Females          %.4f \n',prob_shortsex2_f)

%SOCIETY
ahelp_numerator = ahelp_numerator_m + ahelp_numerator_f;
ahelp_denominator = ahelp_denominator_m + ahelp_denominator_f;
ahelp = ahelp_numerator / ahelp_denominator;
prob_shortsex2 = 1 - ahelp;
% fprintf('Society          %.4f \n',prob_shortsex2)

% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%
%%% MOMENT 5:

% fprintf('\n\n')
% disp('----------- MOMENT 5 ----------------')
% disp('Total number of life-time partners')
% disp('-------------------------------------')
% 
% fprintf('\n')
% disp('NOTE: Life-cycle properties in the Monte Carlo section below (if chosen)')
% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%
%%% MOMENT 6:

% fprintf('\n\n')
% disp('----------- MOMENT 6 ----------------')
% disp('Distribution of beliefs')
% disp('Relative frequency within each group')
% disp('(out of those who have not developed symptoms)')
% disp('(both married and single people)')
% disp('-------------------------------------')

% fprintf('\n')
% fprintf('                      Healthy  Sick   Treated \n\n')
%Males:
frac_healthy_m = zeros(ntypes_m,1);
frac_sick_m    = zeros(ntypes_m,1);
frac_treated_m = zeros(ntypes_m,1);
frac_healthy_y_m = zeros(ntypes_m,1);
frac_sick_y_m    = zeros(ntypes_m,1);
frac_treated_y_m = zeros(ntypes_m,1);
for ii=1:ntypes_m
    frac_healthy_m(ii) = (dist_S_m(i_healthy,ii)+dist_L_m(i_healthy,ii)) / sum(dist_S_m(:,ii)+dist_L_m(:,ii));
    frac_sick_m(ii)    = (dist_S_m(i_sick,ii)+dist_L_m(i_sick,ii)) / sum(dist_S_m(:,ii)+dist_L_m(:,ii));
    frac_treated_m(ii) = (dist_S_m(i_treated,ii)+dist_L_m(i_treated,ii)) / sum(dist_S_m(:,ii)+dist_L_m(:,ii));
    frac_healthy_y_m(ii) = (dist_S_y_m(i_healthy,ii)+dist_L_y_m(i_healthy,ii)) / sum(dist_S_y_m(:,ii)+dist_L_y_m(:,ii));
    frac_sick_y_m(ii)    = (dist_S_y_m(i_sick,ii)+dist_L_y_m(i_sick,ii)) / sum(dist_S_y_m(:,ii)+dist_L_y_m(:,ii));
    frac_treated_y_m(ii) = (dist_S_y_m(i_treated,ii)+dist_L_y_m(i_treated,ii)) / sum(dist_S_y_m(:,ii)+dist_L_y_m(:,ii));
%     fprintf('Male type %.0f (young)   %.4f  %.4f  %.4f \n',ii,frac_healthy_y_m(ii),frac_sick_y_m(ii),frac_treated_y_m(ii))
%     fprintf('Male type %.0f (old)     %.4f  %.4f  %.4f \n',ii,frac_healthy_m(ii),frac_sick_m(ii),frac_treated_m(ii))
end
frac_healthy_all_m = sum(dist_S_all_m(i_healthy,:)+dist_L_all_m(i_healthy,:)) / sum(dist_S_all_m+dist_L_all_m);
frac_sick_all_m    = sum(dist_S_all_m(i_sick,:)+dist_L_all_m(i_sick,:)) / sum(dist_S_all_m+dist_L_all_m);
frac_treated_all_m = sum(dist_S_all_m(i_treated,:)+dist_L_all_m(i_treated,:)) / sum(dist_S_all_m+dist_L_all_m);
% fprintf('Males                 %.4f  %.4f  %.4f \n',frac_healthy_all_m,frac_sick_all_m,frac_treated_all_m)

%Females:
frac_healthy_f = zeros(ntypes_f,1);
frac_sick_f    = zeros(ntypes_f,1);
frac_treated_f = zeros(ntypes_f,1);
frac_healthy_y_f = zeros(ntypes_f,1);
frac_sick_y_f    = zeros(ntypes_f,1);
frac_treated_y_f = zeros(ntypes_f,1);
for ii=1:ntypes_f
    frac_healthy_f(ii) = (dist_S_f(i_healthy,ii)+dist_L_f(i_healthy,ii)) / sum(dist_S_f(:,ii)+dist_L_f(:,ii));
    frac_sick_f(ii)    = (dist_S_f(i_sick,ii)+dist_L_f(i_sick,ii)) / sum(dist_S_f(:,ii)+dist_L_f(:,ii));
    frac_treated_f(ii) = (dist_S_f(i_treated,ii)+dist_L_f(i_treated,ii)) / sum(dist_S_f(:,ii)+dist_L_f(:,ii));
    frac_healthy_y_f(ii) = (dist_S_y_f(i_healthy,ii)+dist_L_y_f(i_healthy,ii)) / sum(dist_S_y_f(:,ii)+dist_L_y_f(:,ii));
    frac_sick_y_f(ii)    = (dist_S_y_f(i_sick,ii)+dist_L_y_f(i_sick,ii)) / sum(dist_S_y_f(:,ii)+dist_L_y_f(:,ii));
    frac_treated_y_f(ii) = (dist_S_y_f(i_treated,ii)+dist_L_y_f(i_treated,ii)) / sum(dist_S_y_f(:,ii)+dist_L_y_f(:,ii));
%     fprintf('Female type %.0f (young) %.4f  %.4f  %.4f \n',ii,frac_healthy_y_f(ii),frac_sick_y_f(ii),frac_treated_y_f(ii))
%     fprintf('Female type %.0f (old)   %.4f  %.4f  %.4f \n',ii,frac_healthy_f(ii),frac_sick_f(ii),frac_treated_f(ii))
end
frac_healthy_all_f = sum(dist_S_all_f(i_healthy,:)+dist_L_all_f(i_healthy,:)) / sum(dist_S_all_f+dist_L_all_f);
frac_sick_all_f    = sum(dist_S_all_f(i_sick,:)+dist_L_all_f(i_sick,:)) / sum(dist_S_all_f+dist_L_all_f);
frac_treated_all_f = sum(dist_S_all_f(i_treated,:)+dist_L_all_f(i_treated,:)) / sum(dist_S_all_f+dist_L_all_f);
% fprintf('Females               %.4f  %.4f  %.4f \n',frac_healthy_all_f,frac_sick_all_f,frac_treated_all_f)

%Everyone:
frac_healthy = sum(dist_S_all_m(i_healthy,:)+dist_S_all_f(i_healthy,:)+dist_L_all_m(i_healthy,:)+dist_L_all_f(i_healthy,:)) ...
    / sum(dist_S_all_m+dist_S_all_f+dist_L_all_m+dist_L_all_f);
frac_sick    = sum(dist_S_all_m(i_sick,:)+dist_S_all_f(i_sick,:)+dist_L_all_m(i_sick,:)+dist_L_all_f(i_sick,:)) ...
    / sum(dist_S_all_m+dist_S_all_f+dist_L_all_m+dist_L_all_f);
frac_treated = sum(dist_S_all_m(i_treated,:)+dist_S_all_f(i_treated,:)+dist_L_all_m(i_treated,:)+dist_L_all_f(i_treated,:)) ...
    / sum(dist_S_all_m+dist_S_all_f+dist_L_all_m+dist_L_all_f);
% fprintf('Society               %.4f  %.4f  %.4f \n',frac_healthy,frac_sick,frac_treated)

% fprintf('\n')
% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%
%%% MOMENT 7:

% fprintf('\n\n')
% disp('----------- MOMENT 7 ----------------')
% disp('Fraction of people ever married')
% disp('at certain ages')
% disp('-------------------------------------')

%We will compute for the following years:
% 22 years in life -> 7 years in the model -> 28 model periods
% 50 years in life -> 35 years in the model -> 140 model periods
last_age = 140;

%Create vector for gammas:
gamma_vec = zeros(n_status,n_gender,2);
gamma_vec(i_healthy,i_male,:) = 1;
gamma_vec(i_healthy,i_female,:) = 1;
gamma_vec(i_sick,i_male,i_protected) = gammap_m;
gamma_vec(i_sick,i_female,i_protected) = gammap_f;
gamma_vec(i_sick,i_male,i_unprotected) = gammau_m;
gamma_vec(i_sick,i_female,i_unprotected) = gammau_f;
gamma_vec(i_treated,i_male,i_protected) = gammap_m_treat;
gamma_vec(i_treated,i_female,i_protected) = gammap_f_treat;
gamma_vec(i_treated,i_male,i_unprotected) = gammau_m_treat;
gamma_vec(i_treated,i_female,i_unprotected) = gammau_f_treat;

%Compute the rates of infectiousness in each short term market:
upsilon_p_m = sum( (1.0-gamma_vec(:,i_male,i_protected)).*measure_p_m + (1.0-gamma_vec(:,i_male,i_protected)).*measure_p_y_m ) / sum(measure_p_m+measure_p_y_m);
upsilon_u_m = sum( (1.0-gamma_vec(:,i_male,i_unprotected)).*measure_u_m + (1.0-gamma_vec(:,i_male,i_unprotected)).*measure_u_y_m ) / sum(measure_u_m+measure_u_y_m);
upsilon_p_f = sum( (1.0-gamma_vec(:,i_female,i_protected)).*measure_p_f + (1.0-gamma_vec(:,i_female,i_protected)).*measure_p_y_f ) / sum(measure_p_f+measure_p_y_f);
upsilon_u_f = sum( (1.0-gamma_vec(:,i_female,i_unprotected)).*measure_u_f + (1.0-gamma_vec(:,i_female,i_unprotected)).*measure_u_y_f ) / sum(measure_u_f+measure_u_y_f);

%Compute fraction of sick/treated in the long term market - males:
frac_sick_m    = (measure_l_m(i_sick)+measure_l_y_m(i_sick)) / sum(measure_l_m+measure_l_y_m);
frac_treated_m = (measure_l_m(i_treated)+measure_l_y_m(i_treated)) / sum(measure_l_m+measure_l_y_m);
frac_l_m_vec = zeros(n_status,1);
frac_l_m_vec(i_healthy) = 1.0 - frac_sick_m - frac_treated_m;
frac_l_m_vec(i_sick)    = frac_sick_m;
frac_l_m_vec(i_treated) = frac_treated_m;
if do_circ==1
    compute_frac_healthy_longterm_bycirc
end

%Compute fraction of sick/treated in the long term market - females:
frac_sick_f    = (measure_l_f(i_sick)+measure_l_y_f(i_sick)) / sum(measure_l_f+measure_l_y_f);
frac_treated_f = (measure_l_f(i_treated)+measure_l_y_f(i_treated)) / sum(measure_l_f+measure_l_y_f);
frac_l_f_vec = zeros(n_status,1);
frac_l_f_vec(i_healthy) = 1.0 - frac_sick_f - frac_treated_f;
frac_l_f_vec(i_sick)    = frac_sick_f;
frac_l_f_vec(i_treated) = frac_treated_f;

%MALES:

%Create the "birth" distribution - young:
dist_S_y_birth = zeros(n_status,ntypes_m);
dist_S_y_birth(i_healthy,:) = (1-eta)*mu_m;
dist_L_y_birth = zeros(n_status,ntypes_m);
dist_L_opp_y_birth = zeros(n_status,n_status,ntypes_m);

%Create the "birth" distribution - old:
dist_S_birth = zeros(n_status,ntypes_m);
dist_S_birth(i_healthy,:) = eta*mu_m;
dist_L_birth = zeros(n_status,ntypes_m);
dist_L_opp_birth = zeros(n_status,n_status,ntypes_m);
dist_A_birth = zeros(n_status,ntypes_m);

%Initialize distributions by age:
dist_S_byage_m = zeros(n_status,ntypes_m,last_age);
dist_S_byage_m(:,:,1) = dist_S_birth;
dist_S_byage_y_m = zeros(n_status,ntypes_m,last_age);
dist_S_byage_y_m(:,:,1) = dist_S_y_birth;
dist_L_byage_m = zeros(n_status,ntypes_m,last_age);
dist_L_byage_y_m = zeros(n_status,ntypes_m,last_age);
dist_L_opp_byage_m = zeros(n_status,n_status,ntypes_m,last_age);
dist_L_opp_byage_y_m = zeros(n_status,n_status,ntypes_m,last_age);
dist_A_byage_m = zeros(n_status,ntypes_m,last_age);

%Some helpful distributions:
dist_S_apply = dist_S_birth;
dist_S_y_apply = dist_S_y_birth;
dist_L_apply = dist_L_birth;
dist_L_y_apply = dist_L_y_birth;
dist_L_opp_apply = dist_L_opp_birth;
dist_L_opp_y_apply = dist_L_opp_y_birth;
dist_A_apply = dist_A_birth;

%More helpful distributions:
dist_S_pr = zeros(n_status,ntypes_m);
dist_S_y_pr = zeros(n_status,ntypes_m);
dist_S_prpr = zeros(n_status,ntypes_m);
dist_S_y_prpr = zeros(n_status,ntypes_m);
dist_L_opp_pr = zeros(n_status,n_status,ntypes_m);
dist_L_opp_y_pr = zeros(n_status,n_status,ntypes_m);
dist_L_opp_prpr = zeros(n_status,n_status,ntypes_m);
dist_L_opp_y_prpr = zeros(n_status,n_status,ntypes_m);

%Loop for distributions by age:
for tt=2:last_age
    for ii=1:ntypes_m
        %SINGLES:
        %Before changing discount factors or treatment status - old agents:
        dist_S_pr(i_healthy,ii) = (1.0-delta) * ( ...
            (1.0-pi_l_m(i_healthy,ii)).*dist_S_apply(i_healthy,ii).*( 1.0-pi_p_m(i_healthy,ii)-pi_u_m(i_healthy,ii) + pi_p_m(i_healthy,ii)*(1.0-upsilon_p_f*chi_m(ii)) + pi_u_m(i_healthy,ii)*(1.0-upsilon_u_f*chi_m(ii)) ) + ...
            sum( (1.0-(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec)).*(1-(1.0-gamma_vec(:,i_female,i_unprotected))*chi_m(ii)).*( dist_L_opp_apply(i_healthy,:,ii)' + frac_l_f_vec.*pi_l_m(i_healthy,ii).*dist_S_apply(i_healthy,ii) ) ) ...
            );
        dist_S_pr(i_sick,ii)    = (1.0-delta) * ( ...
            (1.0-pi_l_m(i_healthy,ii)).*dist_S_apply(i_healthy,ii).*( pi_p_m(i_healthy,ii).*upsilon_p_f*chi_m(ii) + pi_u_m(i_healthy,ii).*upsilon_u_f*chi_m(ii) ) + ...
            (1.0-alpha)*(1.0-pi_l_m(i_sick,ii)).*dist_S_apply(i_sick,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*(1.0-gamma_vec(:,i_female,i_unprotected))*chi_m(ii).*( dist_L_opp_apply(i_healthy,:,ii)' + frac_l_f_vec.*pi_l_m(i_healthy,ii).*dist_S_apply(i_healthy,ii) ) ) + ...
            (1.0-alpha)*sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_apply(i_sick,:,ii)' + frac_l_f_vec.*pi_l_m(i_sick,ii).*dist_S_apply(i_sick,ii) ) ) ...
            );
        dist_S_pr(i_treated,ii) = (1.0-delta)*(1.0-alpha_treat) * ( ...
            (1.0-pi_l_m(i_treated,ii)).*dist_S_apply(i_treated,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_apply(i_treated,:,ii)' + frac_l_f_vec.*pi_l_m(i_treated,ii).*dist_S_apply(i_treated,ii) ) ) ...
            );
        %Before changing discount factors or treatment status - young agents:
        dist_S_y_pr(i_healthy,ii) = (1.0-delta) * ( ...
            (1.0-pi_l_y_m(i_healthy,ii)).*dist_S_y_apply(i_healthy,ii).*( 1.0-pi_p_y_m(i_healthy,ii)-pi_u_y_m(i_healthy,ii) + pi_p_y_m(i_healthy,ii)*(1.0-upsilon_p_f*chi_m(ii)) + pi_u_y_m(i_healthy,ii)*(1.0-upsilon_u_f*chi_m(ii)) ) + ...
            sum( (1.0-(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec)).*(1-(1.0-gamma_vec(:,i_female,i_unprotected))*chi_m(ii)).*( dist_L_opp_y_apply(i_healthy,:,ii)' + frac_l_f_vec.*pi_l_y_m(i_healthy,ii).*dist_S_y_apply(i_healthy,ii) ) ) ...
            );
        dist_S_y_pr(i_sick,ii)    = (1.0-delta) * ( ...
            (1.0-pi_l_y_m(i_healthy,ii)).*dist_S_y_apply(i_healthy,ii).*( pi_p_y_m(i_healthy,ii)*upsilon_p_f*chi_m(ii) + pi_u_y_m(i_healthy,ii)*upsilon_u_f*chi_m(ii) ) + ...
            (1.0-alpha)*(1.0-pi_l_y_m(i_sick,ii)).*dist_S_y_apply(i_sick,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*(1.0-gamma_vec(:,i_female,i_unprotected))*chi_m(ii).*( dist_L_opp_y_apply(i_healthy,:,ii)' + frac_l_f_vec.*pi_l_y_m(i_healthy,ii).*dist_S_y_apply(i_healthy,ii) ) ) + ...
            (1.0-alpha)*sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_y_apply(i_sick,:,ii)' + frac_l_f_vec.*pi_l_y_m(i_sick,ii).*dist_S_y_apply(i_sick,ii) ) ) ...
            );
        dist_S_y_pr(i_treated,ii) = (1.0-delta)*(1.0-alpha_treat) * ( ...
            (1.0-pi_l_y_m(i_treated,ii)).*dist_S_y_apply(i_treated,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_y_apply(i_treated,:,ii)' + frac_l_f_vec.*pi_l_y_m(i_treated,ii).*dist_S_y_apply(i_treated,ii) ) ) ...
            );
        %Changing the discount factor:
        dist_S_prpr(:,ii) = dist_S_pr(:,ii) + eta*dist_S_y_pr(:,ii);
        dist_S_y_prpr(:,ii) = (1.0-eta)*dist_S_y_pr(:,ii);
        %Changing treatment status:
        dist_S_byage_m(i_healthy,ii,tt) = dist_S_prpr(i_healthy,ii);
        dist_S_byage_m(i_sick,ii,tt)    = dist_S_prpr(i_sick,ii)*(1.0-q);
        dist_S_byage_m(i_treated,ii,tt) = dist_S_prpr(i_sick,ii)*q + dist_S_prpr(i_treated,ii);
        dist_S_byage_y_m(i_healthy,ii,tt) = dist_S_y_prpr(i_healthy,ii);
        dist_S_byage_y_m(i_sick,ii,tt)    = dist_S_y_prpr(i_sick,ii)*(1.0-q);
        dist_S_byage_y_m(i_treated,ii,tt) = dist_S_y_prpr(i_sick,ii)*q + dist_S_y_prpr(i_treated,ii);
        
        %MARRIED:
        %Before changing discount factors or treatment status - old agents:
        dist_L_opp_pr(i_healthy,:,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec).*(1-(1-gamma_vec(:,i_female,i_unprotected))*chi_m(ii)).*( dist_L_opp_apply(i_healthy,:,ii)' + frac_l_f_vec.*pi_l_m(i_healthy,ii)*dist_S_apply(i_healthy,ii) );
        dist_L_opp_pr(i_sick,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*gammau_m*( dist_L_opp_apply(i_sick,i_healthy,ii) + (1.0-frac_sick_f-frac_treated_f)*pi_l_m(i_sick,ii)*dist_S_apply(i_sick,ii) );
        dist_L_opp_pr(i_sick,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha)*( dist_L_opp_apply(i_sick,i_sick,ii) + frac_sick_f*pi_l_m(i_sick,ii)*dist_S_apply(i_sick,ii) );
        dist_L_opp_pr(i_sick,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha_treat)*( dist_L_opp_apply(i_sick,i_treated,ii) + frac_treated_f*pi_l_m(i_sick,ii)*dist_S_apply(i_sick,ii) );
        dist_L_opp_pr(i_treated,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*gammau_m_treat*( dist_L_opp_apply(i_treated,i_healthy,ii) + (1.0-frac_sick_f-frac_treated_f)*pi_l_m(i_treated,ii)*dist_S_apply(i_treated,ii) );
        dist_L_opp_pr(i_treated,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha)*( dist_L_opp_apply(i_treated,i_sick,ii) + frac_sick_f*pi_l_m(i_treated,ii)*dist_S_apply(i_treated,ii) );
        dist_L_opp_pr(i_treated,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha_treat)*( dist_L_opp_apply(i_treated,i_treated,ii) + frac_treated_f*pi_l_m(i_treated,ii)*dist_S_apply(i_treated,ii) );
        %Before changing discount factors or treatment status - young agents:
        dist_L_opp_y_pr(i_healthy,:,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec).*(1-(1-gamma_vec(:,i_female,i_unprotected))*chi_m(ii)).*( dist_L_opp_y_apply(i_healthy,:,ii)' + frac_l_f_vec*pi_l_y_m(i_healthy,ii)*dist_S_y_apply(i_healthy,ii) );
        dist_L_opp_y_pr(i_sick,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*gammau_m*( dist_L_opp_y_apply(i_sick,i_healthy,ii) + (1.0-frac_sick_f-frac_treated_f)*pi_l_y_m(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
        dist_L_opp_y_pr(i_sick,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha)*( dist_L_opp_y_apply(i_sick,i_sick,ii) + frac_sick_f*pi_l_y_m(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
        dist_L_opp_y_pr(i_sick,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha_treat)*( dist_L_opp_y_apply(i_sick,i_treated,ii) + frac_treated_f*pi_l_y_m(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
        dist_L_opp_y_pr(i_treated,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*gammau_m_treat*( dist_L_opp_y_apply(i_treated,i_healthy,ii) + (1.0-frac_sick_f-frac_treated_f)*pi_l_y_m(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
        dist_L_opp_y_pr(i_treated,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha)*( dist_L_opp_y_apply(i_treated,i_sick,ii) + frac_sick_f*pi_l_y_m(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
        dist_L_opp_y_pr(i_treated,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha_treat)*( dist_L_opp_y_apply(i_treated,i_treated,ii) + frac_treated_f*pi_l_y_m(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
        %Changing the discount factors:
        dist_L_opp_prpr(:,:,ii) = dist_L_opp_pr(:,:,ii) + eta*dist_L_opp_y_pr(:,:,ii);
        dist_L_opp_y_prpr(:,:,ii) = (1.0-eta)*dist_L_opp_y_pr(:,:,ii);
        %Chaging treatment status - old agents:
        dist_L_opp_byage_m(i_healthy,i_healthy,ii,tt) = dist_L_opp_prpr(i_healthy,i_healthy,ii);
        dist_L_opp_byage_m(i_healthy,i_sick,ii,tt)    = dist_L_opp_prpr(i_healthy,i_sick,ii)*(1.0-q);
        dist_L_opp_byage_m(i_healthy,i_treated,ii,tt) = dist_L_opp_prpr(i_healthy,i_sick,ii)*q + dist_L_opp_prpr(i_healthy,i_treated,ii);
        dist_L_opp_byage_m(i_sick,i_healthy,ii,tt)    = dist_L_opp_prpr(i_sick,i_healthy,ii)*(1.0-q);
        dist_L_opp_byage_m(i_sick,i_sick,ii,tt)       = dist_L_opp_prpr(i_sick,i_sick,ii)*(1.0-q)*(1.0-q);
        dist_L_opp_byage_m(i_sick,i_treated,ii,tt)    = dist_L_opp_prpr(i_sick,i_treated,ii)*(1.0-q) + dist_L_opp_prpr(i_sick,i_sick,ii)*(1.0-q)*q;
        dist_L_opp_byage_m(i_treated,i_healthy,ii,tt) = dist_L_opp_prpr(i_sick,i_healthy,ii)*q + dist_L_opp_prpr(i_treated,i_healthy,ii);
        dist_L_opp_byage_m(i_treated,i_sick,ii,tt)    = dist_L_opp_prpr(i_treated,i_sick,ii)*(1.0-q) + dist_L_opp_prpr(i_sick,i_sick,ii)*q*(1.0-q);
        dist_L_opp_byage_m(i_treated,i_treated,ii,tt) = dist_L_opp_prpr(i_treated,i_treated,ii) + dist_L_opp_prpr(i_sick,i_treated,ii)*q + dist_L_opp_prpr(i_treated,i_sick,ii)*q + dist_L_opp_prpr(i_sick,i_sick,ii)*q*q;
        %Changing treatment status - young agents:
        dist_L_opp_byage_y_m(i_healthy,i_healthy,ii,tt) = dist_L_opp_y_prpr(i_healthy,i_healthy,ii);
        dist_L_opp_byage_y_m(i_healthy,i_sick,ii,tt)    = dist_L_opp_y_prpr(i_healthy,i_sick,ii)*(1.0-q);
        dist_L_opp_byage_y_m(i_healthy,i_treated,ii,tt) = dist_L_opp_y_prpr(i_healthy,i_sick,ii)*q + dist_L_opp_y_prpr(i_healthy,i_treated,ii);
        dist_L_opp_byage_y_m(i_sick,i_healthy,ii,tt)    = dist_L_opp_y_prpr(i_sick,i_healthy,ii)*(1.0-q);
        dist_L_opp_byage_y_m(i_sick,i_sick,ii,tt)       = dist_L_opp_y_prpr(i_sick,i_sick,ii)*(1.0-q)*(1.0-q);
        dist_L_opp_byage_y_m(i_sick,i_treated,ii,tt)    = dist_L_opp_y_prpr(i_sick,i_treated,ii)*(1.0-q) + dist_L_opp_y_prpr(i_sick,i_sick,ii)*(1.0-q)*q;
        dist_L_opp_byage_y_m(i_treated,i_healthy,ii,tt) = dist_L_opp_y_prpr(i_sick,i_healthy,ii)*q + dist_L_opp_y_prpr(i_treated,i_healthy,ii);
        dist_L_opp_byage_y_m(i_treated,i_sick,ii,tt)    = dist_L_opp_y_prpr(i_treated,i_sick,ii)*(1.0-q) + dist_L_opp_y_prpr(i_sick,i_sick,ii)*q*(1.0-q);
        dist_L_opp_byage_y_m(i_treated,i_treated,ii,tt) = dist_L_opp_y_prpr(i_treated,i_treated,ii) + dist_L_opp_y_prpr(i_sick,i_treated,ii)*q + dist_L_opp_y_prpr(i_treated,i_sick,ii)*q + dist_L_opp_y_prpr(i_sick,i_sick,ii)*q*q;
        %Consolidating across partner's type:
        dist_L_byage_m(:,ii,tt) = sum(dist_L_opp_byage_m(:,:,ii,tt),2);
        dist_L_byage_y_m(:,ii,tt) = sum(dist_L_opp_byage_y_m(:,:,ii,tt),2);
        
        %WITH SYMPTOMS:
        dist_A_byage_m(:,ii,tt) = (1.0-delta)*( (1.0-delta2)*dist_A_apply(:,ii) + (dist_S_apply(:,ii) + dist_S_y_apply(:,ii) + dist_L_apply(:,ii) + dist_L_y_apply(:,ii)).*alpha_vec );
        
    end
        
    %UPDATE "APPLY" DISTRIBUTIONS:
    dist_S_apply = dist_S_byage_m(:,:,tt);
    dist_S_y_apply = dist_S_byage_y_m(:,:,tt);
    dist_L_apply = dist_L_byage_m(:,:,tt);
    dist_L_y_apply = dist_L_byage_y_m(:,:,tt);
    dist_L_opp_apply = dist_L_opp_byage_m(:,:,:,tt);
    dist_L_opp_y_apply = dist_L_opp_byage_y_m(:,:,:,tt);
    dist_A_apply = dist_A_byage_m(:,:,tt);
    
end

%Initialize distributions by age - NEVER MARRIED:
dist_S_nm_byage_m = zeros(n_status,ntypes_m,last_age);
dist_S_nm_byage_m(:,:,1) = dist_S_birth;
dist_S_nm_byage_y_m = zeros(n_status,ntypes_m,last_age);
dist_S_nm_byage_y_m(:,:,1) = dist_S_y_birth;
dist_A_nm_byage_m = zeros(n_status,ntypes_m,last_age);

%Some helpful distributions - NEVER MARRIED:
dist_S_nm_apply = dist_S_birth;
dist_S_nm_y_apply = dist_S_y_birth;
dist_A_nm_apply = dist_A_birth;

%More helpful distributions - NEVER MARRIED:
dist_S_nm_pr = zeros(n_status,ntypes_m);
dist_S_nm_y_pr = zeros(n_status,ntypes_m);
dist_S_nm_prpr = zeros(n_status,ntypes_m);
dist_S_nm_y_prpr = zeros(n_status,ntypes_m);

%Loop for distributions by age for NEVER MARRIED agents:
for tt=2:last_age
    for ii=1:ntypes_m
        %SINGLES
        %Before changing the discount factor - old agents:
        dist_S_nm_pr(i_healthy,ii) = (1-delta)*(1-pi_l_m(i_healthy,ii))*dist_S_nm_apply(i_healthy,ii)*( 1-pi_p_m(i_healthy,ii)-pi_u_m(i_healthy,ii) + pi_p_m(i_healthy,ii)*(1-upsilon_p_f*chi_m(ii)) + pi_u_m(i_healthy,ii)*(1-upsilon_u_f*chi_m(ii)) );
        dist_S_nm_pr(i_sick,ii)    = (1-delta)*( (1-pi_l_m(i_healthy,ii))*dist_S_nm_apply(i_healthy,ii)*(pi_p_m(i_healthy,ii)*upsilon_p_f*chi_m(ii)+pi_u_m(i_healthy,ii)*upsilon_u_f*chi_m(ii)) + (1-alpha)*(1-pi_l_m(i_sick,ii))*dist_S_nm_apply(i_sick,ii) );
        dist_S_nm_pr(i_treated,ii) = (1-delta)*(1-alpha_treat)*(1-pi_l_m(i_treated,ii))*dist_S_nm_apply(i_treated,ii);
        %Before changing the discount factor - young agents:
        dist_S_nm_y_pr(i_healthy,ii) = (1-delta)*(1-pi_l_y_m(i_healthy,ii))*dist_S_nm_y_apply(i_healthy,ii)*( 1-pi_p_y_m(i_healthy,ii)-pi_u_y_m(i_healthy,ii) + pi_p_y_m(i_healthy,ii)*(1-upsilon_p_f*chi_m(ii)) + pi_u_y_m(i_healthy,ii)*(1-upsilon_u_f*chi_m(ii)) );
        dist_S_nm_y_pr(i_sick,ii)    = (1-delta)*( (1-pi_l_y_m(i_healthy,ii))*dist_S_nm_y_apply(i_healthy,ii)*(pi_p_y_m(i_healthy,ii)*upsilon_p_f*chi_m(ii)+pi_u_y_m(i_healthy,ii)*upsilon_u_f*chi_m(ii)) + (1-alpha)*(1-pi_l_y_m(i_sick,ii))*dist_S_nm_y_apply(i_sick,ii) );
        dist_S_nm_y_pr(i_treated,ii) = (1-delta)*(1-alpha_treat)*(1-pi_l_y_m(i_treated,ii))*dist_S_nm_y_apply(i_treated,ii);
        %Changing the discount factor:
        dist_S_nm_prpr(:,ii) = dist_S_nm_pr(:,ii) + eta*dist_S_nm_y_pr(:,ii);
        dist_S_nm_y_prpr(:,ii) = (1.0-eta)*dist_S_nm_y_pr(:,ii);
        %Changing treatment status:
        dist_S_nm_byage_m(i_healthy,ii,tt) = dist_S_nm_prpr(i_healthy,ii);
        dist_S_nm_byage_m(i_sick,ii,tt)    = dist_S_nm_prpr(i_sick,ii)*(1.0-q);
        dist_S_nm_byage_m(i_treated,ii,tt) = dist_S_nm_prpr(i_sick,ii)*q + dist_S_nm_prpr(i_treated,ii);
        dist_S_nm_byage_y_m(i_healthy,ii,tt) = dist_S_nm_y_prpr(i_healthy,ii);
        dist_S_nm_byage_y_m(i_sick,ii,tt)    = dist_S_nm_y_prpr(i_sick,ii)*(1.0-q);
        dist_S_nm_byage_y_m(i_treated,ii,tt) = dist_S_nm_y_prpr(i_sick,ii)*q + dist_S_nm_y_prpr(i_treated,ii);
        
        %WITH SYMPTOMS:
        dist_A_nm_byage_m(:,ii,tt) = (1.0-delta)*( (1.0-delta2)*dist_A_nm_apply(:,ii) + (dist_S_nm_apply(:,ii).*(1-pi_l_m(:,ii)) + dist_S_nm_y_apply(:,ii).*(1-pi_l_y_m(:,ii))).*alpha_vec );
        
    end
        
    %UPDATE "APPLY" DISTRIBUTIONS:
    dist_S_nm_apply = dist_S_nm_byage_m(:,:,tt);
    dist_S_nm_y_apply = dist_S_nm_byage_y_m(:,:,tt);
    dist_A_nm_apply = dist_A_nm_byage_m(:,:,tt);
    
end

%Compute fraction of never-married people:
nevermarried_m = zeros(last_age,1);
for tt=1:last_age
    nevermarried_m(tt) = sum(sum( dist_S_nm_byage_m(:,:,tt)+dist_S_nm_byage_y_m(:,:,tt)+dist_A_nm_byage_m(:,:,tt) )) / ...
        sum(sum( dist_S_byage_m(:,:,tt)+dist_S_byage_y_m(:,:,tt)+dist_A_byage_m(:,:,tt)+dist_L_byage_m(:,:,tt)+dist_L_byage_y_m(:,:,tt) ));
end

evermarried_m = 1 - nevermarried_m;

% fprintf('Males - age 22   %.4f \n',evermarried_m(28))
% fprintf('Males - age 50   %.4f \n',evermarried_m(140))

%FEMALES:

%Create the "birth" distribution - young:
dist_S_y_birth = zeros(n_status,ntypes_f);
dist_S_y_birth(i_healthy,:) = (1-eta)*mu_f;
dist_L_y_birth = zeros(n_status,ntypes_f);
dist_L_opp_y_birth = zeros(n_status,n_status,ntypes_f);
dist_L_opp_bycirc_y_birth = zeros(n_status,n_circ,ntypes_f);

%Create the "birth" distribution - old:
dist_S_birth = zeros(n_status,ntypes_f);
dist_S_birth(i_healthy,:) = eta*mu_f;
dist_L_birth = zeros(n_status,ntypes_f);
dist_L_opp_birth = zeros(n_status,n_status,ntypes_f);
dist_L_opp_bycirc_birth = zeros(n_status,n_circ,ntypes_f);
dist_A_birth = zeros(n_status,ntypes_f);

%Initialize distributions by age:
dist_S_byage_f = zeros(n_status,ntypes_f,last_age);
dist_S_byage_f(:,:,1) = dist_S_birth;
dist_S_byage_y_f = zeros(n_status,ntypes_f,last_age);
dist_S_byage_y_f(:,:,1) = dist_S_y_birth;
dist_L_byage_f = zeros(n_status,ntypes_f,last_age);
dist_L_byage_y_f = zeros(n_status,ntypes_f,last_age);
dist_L_opp_byage_f = zeros(n_status,n_status,ntypes_f,last_age);
dist_L_opp_byage_y_f = zeros(n_status,n_status,ntypes_f,last_age);
dist_L_opp_bycirc_byage_f = zeros(n_status,n_circ,ntypes_f,last_age);
dist_L_opp_bycirc_byage_y_f = zeros(n_status,n_circ,ntypes_f,last_age);
dist_A_byage_f = zeros(n_status,ntypes_f,last_age);

%Some helpful distributions:
dist_S_apply = dist_S_birth;
dist_S_y_apply = dist_S_y_birth;
dist_L_apply = dist_L_birth;
dist_L_y_apply = dist_L_y_birth;
dist_L_opp_apply = dist_L_opp_birth;
dist_L_opp_y_apply = dist_L_opp_y_birth;
dist_L_opp_bycirc_apply = dist_L_opp_bycirc_birth;
dist_L_opp_bycirc_y_apply = dist_L_opp_bycirc_y_birth;
dist_A_apply = dist_A_birth;

%More helpful distributions:
dist_S_pr = zeros(n_status,ntypes_f);
dist_S_y_pr = zeros(n_status,ntypes_f);
dist_S_prpr = zeros(n_status,ntypes_f);
dist_S_y_prpr = zeros(n_status,ntypes_f);
dist_L_opp_pr = zeros(n_status,n_status,ntypes_f);
dist_L_opp_y_pr = zeros(n_status,n_status,ntypes_f);
dist_L_opp_bycirc_pr = zeros(n_status,n_circ,ntypes_f);
dist_L_opp_bycirc_y_pr = zeros(n_status,n_circ,ntypes_f);
dist_L_opp_prpr = zeros(n_status,n_status,ntypes_f);
dist_L_opp_y_prpr = zeros(n_status,n_status,ntypes_f);
dist_L_opp_bycirc_prpr = zeros(n_status,n_circ,ntypes_f);
dist_L_opp_bycirc_y_prpr = zeros(n_status,n_circ,ntypes_f);

%Loop for distributions by age:
for tt=2:last_age
    for ii=1:ntypes_f
        %SINGLES:
        %Before changing discount factors or treatment status - old agents:
        dist_S_pr(i_healthy,ii) = (1.0-delta) * ( ...
            (1.0-pi_l_f(i_healthy,ii)).*dist_S_apply(i_healthy,ii).*( 1.0-pi_p_f(i_healthy,ii)-pi_u_f(i_healthy,ii) + pi_p_f(i_healthy,ii)*(1.0-upsilon_p_m*chi_f(ii)) + pi_u_f(i_healthy,ii)*(1.0-upsilon_u_m*chi_f(ii)) ) + ...
            sum( (1.0-(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec)).*(1-(1.0-gamma_vec(:,i_male,i_unprotected))*chi_f(ii)).*( dist_L_opp_apply(i_healthy,:,ii)' + frac_l_m_vec.*pi_l_f(i_healthy,ii).*dist_S_apply(i_healthy,ii) ) ) ...
            );
        dist_S_pr(i_sick,ii)    = (1.0-delta) * ( ...
            (1.0-pi_l_f(i_healthy,ii)).*dist_S_apply(i_healthy,ii).*( pi_p_f(i_healthy,ii).*upsilon_p_m*chi_f(ii) + pi_u_f(i_healthy,ii).*upsilon_u_m*chi_f(ii) ) + ...
            (1.0-alpha)*(1.0-pi_l_f(i_sick,ii)).*dist_S_apply(i_sick,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*(1.0-gamma_vec(:,i_male,i_unprotected))*chi_f(ii).*( dist_L_opp_apply(i_healthy,:,ii)' + frac_l_m_vec.*pi_l_f(i_healthy,ii).*dist_S_apply(i_healthy,ii) ) ) + ...
            (1.0-alpha)*sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_apply(i_sick,:,ii)' + frac_l_m_vec.*pi_l_f(i_sick,ii).*dist_S_apply(i_sick,ii) ) ) ...
            );
        dist_S_pr(i_treated,ii) = (1.0-delta)*(1.0-alpha_treat) * ( ...
            (1.0-pi_l_f(i_treated,ii)).*dist_S_apply(i_treated,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_apply(i_treated,:,ii)' + frac_l_m_vec.*pi_l_f(i_treated,ii).*dist_S_apply(i_treated,ii) ) ) ...
            );
        %Before changing discount factors or treatment status - young agents:
        dist_S_y_pr(i_healthy,ii) = (1.0-delta) * ( ...
            (1.0-pi_l_y_f(i_healthy,ii)).*dist_S_y_apply(i_healthy,ii).*( 1.0-pi_p_y_f(i_healthy,ii)-pi_u_y_f(i_healthy,ii) + pi_p_y_f(i_healthy,ii)*(1.0-upsilon_p_m*chi_f(ii)) + pi_u_y_f(i_healthy,ii)*(1.0-upsilon_u_m*chi_f(ii)) ) + ...
            sum( (1.0-(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec)).*(1-(1.0-gamma_vec(:,i_male,i_unprotected))*chi_f(ii)).*( dist_L_opp_y_apply(i_healthy,:,ii)' + frac_l_m_vec.*pi_l_y_f(i_healthy,ii).*dist_S_y_apply(i_healthy,ii) ) ) ...
            );
        dist_S_y_pr(i_sick,ii)    = (1.0-delta) * ( ...
            (1.0-pi_l_y_f(i_healthy,ii)).*dist_S_y_apply(i_healthy,ii).*( pi_p_y_f(i_healthy,ii)*upsilon_p_m*chi_f(ii) + pi_u_y_f(i_healthy,ii)*upsilon_u_m*chi_f(ii) ) + ...
            (1.0-alpha)*(1.0-pi_l_y_f(i_sick,ii)).*dist_S_y_apply(i_sick,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*(1.0-gamma_vec(:,i_male,i_unprotected))*chi_f(ii).*( dist_L_opp_y_apply(i_healthy,:,ii)' + frac_l_m_vec.*pi_l_y_f(i_healthy,ii).*dist_S_y_apply(i_healthy,ii) ) ) + ...
            (1.0-alpha)*sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_y_apply(i_sick,:,ii)' + frac_l_m_vec.*pi_l_y_f(i_sick,ii).*dist_S_y_apply(i_sick,ii) ) ) ...
            );
        dist_S_y_pr(i_treated,ii) = (1.0-delta)*(1.0-alpha_treat) * ( ...
            (1.0-pi_l_y_f(i_treated,ii)).*dist_S_y_apply(i_treated,ii) + ...
            sum( (1.0-(1.0-delta)*(1.0-alpha_vec)*(1.0-epsilon)).*( dist_L_opp_y_apply(i_treated,:,ii)' + frac_l_m_vec.*pi_l_y_f(i_treated,ii).*dist_S_y_apply(i_treated,ii) ) ) ...
            );
        %Changing the discount factor:
        dist_S_prpr(:,ii) = dist_S_pr(:,ii) + eta*dist_S_y_pr(:,ii);
        dist_S_y_prpr(:,ii) = (1.0-eta)*dist_S_y_pr(:,ii);
        %Changing treatment status:
        dist_S_byage_f(i_healthy,ii,tt) = dist_S_prpr(i_healthy,ii);
        dist_S_byage_f(i_sick,ii,tt)    = dist_S_prpr(i_sick,ii)*(1.0-q);
        dist_S_byage_f(i_treated,ii,tt) = dist_S_prpr(i_sick,ii)*q + dist_S_prpr(i_treated,ii);
        dist_S_byage_y_f(i_healthy,ii,tt) = dist_S_y_prpr(i_healthy,ii);
        dist_S_byage_y_f(i_sick,ii,tt)    = dist_S_y_prpr(i_sick,ii)*(1.0-q);
        dist_S_byage_y_f(i_treated,ii,tt) = dist_S_y_prpr(i_sick,ii)*q + dist_S_y_prpr(i_treated,ii);
        
        %MARRIED:
        %Before changing discount factors or treatment status - old agents:
        dist_L_opp_pr(i_healthy,:,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec).*(1-(1-gamma_vec(:,i_male,i_unprotected))*chi_f(ii)).*( dist_L_opp_apply(i_healthy,:,ii)' + frac_l_m_vec.*pi_l_f(i_healthy,ii)*dist_S_apply(i_healthy,ii) );
        if do_circ==1
            dist_L_opp_bycirc_pr(i_sick,i_nocirc,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*gammau_f*( dist_L_opp_bycirc_apply(i_sick,i_nocirc,ii) + frac_healthy_nocirc_m*pi_l_f(i_sick,ii)*dist_S_apply(i_sick,ii) );
            dist_L_opp_bycirc_pr(i_sick,i_circ,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-(1.0-gammau_f)*chi_circ)*( dist_L_opp_bycirc_apply(i_sick,i_circ,ii) + frac_healthy_circ_m*pi_l_f(i_sick,ii)*dist_S_apply(i_sick,ii) );
            dist_L_opp_pr(i_sick,i_healthy,ii) = dist_L_opp_bycirc_pr(i_sick,i_nocirc,ii) + dist_L_opp_bycirc_pr(i_sick,i_circ,ii);
        else
            dist_L_opp_pr(i_sick,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*gammau_f*( dist_L_opp_apply(i_sick,i_healthy,ii) + (1.0-frac_sick_m-frac_treated_m)*pi_l_f(i_sick,ii)*dist_S_apply(i_sick,ii) );
        end
        dist_L_opp_pr(i_sick,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha)*( dist_L_opp_apply(i_sick,i_sick,ii) + frac_sick_m*pi_l_f(i_sick,ii)*dist_S_apply(i_sick,ii) );
        dist_L_opp_pr(i_sick,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha_treat)*( dist_L_opp_apply(i_sick,i_treated,ii) + frac_treated_m*pi_l_f(i_sick,ii)*dist_S_apply(i_sick,ii) );
        if do_circ==1
            dist_L_opp_bycirc_pr(i_treated,i_nocirc,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*gammau_f_treat*( dist_L_opp_bycirc_apply(i_treated,i_nocirc,ii) + frac_healthy_nocirc_m*pi_l_f(i_treated,ii)*dist_S_apply(i_treated,ii) );
            dist_L_opp_bycirc_pr(i_treated,i_circ,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-(1.0-gammau_f_treat)*chi_circ)*( dist_L_opp_bycirc_apply(i_treated,i_circ,ii) + frac_healthy_circ_m*pi_l_f(i_treated,ii)*dist_S_apply(i_treated,ii) );
            dist_L_opp_pr(i_treated,i_healthy,ii) = dist_L_opp_bycirc_pr(i_treated,i_nocirc,ii) + dist_L_opp_bycirc_pr(i_treated,i_circ,ii);
        else
            dist_L_opp_pr(i_treated,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*gammau_f_treat*( dist_L_opp_apply(i_treated,i_healthy,ii) + (1.0-frac_sick_m-frac_treated_m)*pi_l_f(i_treated,ii)*dist_S_apply(i_treated,ii) );
        end
        dist_L_opp_pr(i_treated,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha)*( dist_L_opp_apply(i_treated,i_sick,ii) + frac_sick_m*pi_l_f(i_treated,ii)*dist_S_apply(i_treated,ii) );
        dist_L_opp_pr(i_treated,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha_treat)*( dist_L_opp_apply(i_treated,i_treated,ii) + frac_treated_m*pi_l_f(i_treated,ii)*dist_S_apply(i_treated,ii) );
        %Before changing discount factors or treatment status - young agents:
        dist_L_opp_y_pr(i_healthy,:,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_vec).*(1-(1-gamma_vec(:,i_male,i_unprotected))*chi_f(ii)).*( dist_L_opp_y_apply(i_healthy,:,ii)' + frac_l_m_vec*pi_l_y_f(i_healthy,ii)*dist_S_y_apply(i_healthy,ii) );
        if do_circ==1
            dist_L_opp_bycirc_y_pr(i_sick,i_nocirc,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*gammau_f*( dist_L_opp_bycirc_y_apply(i_sick,i_nocirc,ii) + frac_healthy_nocirc_m*pi_l_y_f(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
            dist_L_opp_bycirc_y_pr(i_sick,i_circ,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-(1.0-gammau_f)*chi_circ)*( dist_L_opp_bycirc_y_apply(i_sick,i_circ,ii) + frac_healthy_circ_m*pi_l_y_f(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
            dist_L_opp_y_pr(i_sick,i_healthy,ii) = dist_L_opp_bycirc_y_pr(i_sick,i_nocirc,ii) + dist_L_opp_bycirc_y_pr(i_sick,i_circ,ii);
        else
            dist_L_opp_y_pr(i_sick,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*gammau_f*( dist_L_opp_y_apply(i_sick,i_healthy,ii) + (1.0-frac_sick_m-frac_treated_m)*pi_l_y_f(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
        end
        dist_L_opp_y_pr(i_sick,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha)*( dist_L_opp_y_apply(i_sick,i_sick,ii) + frac_sick_m*pi_l_y_f(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
        dist_L_opp_y_pr(i_sick,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha)*(1.0-alpha_treat)*( dist_L_opp_y_apply(i_sick,i_treated,ii) + frac_treated_m*pi_l_y_f(i_sick,ii)*dist_S_y_apply(i_sick,ii) );
        if do_circ==1
            dist_L_opp_bycirc_y_pr(i_treated,i_nocirc,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*gammau_f_treat*( dist_L_opp_bycirc_y_apply(i_treated,i_nocirc,ii) + frac_healthy_nocirc_m*pi_l_y_f(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
            dist_L_opp_bycirc_y_pr(i_treated,i_circ,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-(1.0-gammau_f_treat)*chi_circ)*( dist_L_opp_bycirc_y_apply(i_treated,i_circ,ii) + frac_healthy_circ_m*pi_l_y_f(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
            dist_L_opp_y_pr(i_treated,i_healthy,ii) = dist_L_opp_bycirc_y_pr(i_treated,i_nocirc,ii) + dist_L_opp_bycirc_y_pr(i_treated,i_circ,ii);
        else
            dist_L_opp_y_pr(i_treated,i_healthy,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*gammau_f_treat*( dist_L_opp_y_apply(i_treated,i_healthy,ii) + (1.0-frac_sick_m-frac_treated_m)*pi_l_y_f(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
        end
        dist_L_opp_y_pr(i_treated,i_sick,ii)    = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha)*( dist_L_opp_y_apply(i_treated,i_sick,ii) + frac_sick_m*pi_l_y_f(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
        dist_L_opp_y_pr(i_treated,i_treated,ii) = (1.0-delta)*(1.0-delta)*(1.0-epsilon)*(1.0-alpha_treat)*(1.0-alpha_treat)*( dist_L_opp_y_apply(i_treated,i_treated,ii) + frac_treated_m*pi_l_y_f(i_treated,ii)*dist_S_y_apply(i_treated,ii) );
        %Changing the discount factors:
        dist_L_opp_prpr(:,:,ii) = dist_L_opp_pr(:,:,ii) + eta*dist_L_opp_y_pr(:,:,ii);
        dist_L_opp_y_prpr(:,:,ii) = (1.0-eta)*dist_L_opp_y_pr(:,:,ii);
        %Chaging treatment status - old agents:
        dist_L_opp_byage_f(i_healthy,i_healthy,ii,tt) = dist_L_opp_prpr(i_healthy,i_healthy,ii);
        dist_L_opp_byage_f(i_healthy,i_sick,ii,tt)    = dist_L_opp_prpr(i_healthy,i_sick,ii)*(1.0-q);
        dist_L_opp_byage_f(i_healthy,i_treated,ii,tt) = dist_L_opp_prpr(i_healthy,i_sick,ii)*q + dist_L_opp_prpr(i_healthy,i_treated,ii);
        dist_L_opp_byage_f(i_sick,i_healthy,ii,tt)    = dist_L_opp_prpr(i_sick,i_healthy,ii)*(1.0-q);
        dist_L_opp_byage_f(i_sick,i_sick,ii,tt)       = dist_L_opp_prpr(i_sick,i_sick,ii)*(1.0-q)*(1.0-q);
        dist_L_opp_byage_f(i_sick,i_treated,ii,tt)    = dist_L_opp_prpr(i_sick,i_treated,ii)*(1.0-q) + dist_L_opp_prpr(i_sick,i_sick,ii)*(1.0-q)*q;
        dist_L_opp_byage_f(i_treated,i_healthy,ii,tt) = dist_L_opp_prpr(i_sick,i_healthy,ii)*q + dist_L_opp_prpr(i_treated,i_healthy,ii);
        dist_L_opp_byage_f(i_treated,i_sick,ii,tt)    = dist_L_opp_prpr(i_treated,i_sick,ii)*(1.0-q) + dist_L_opp_prpr(i_sick,i_sick,ii)*q*(1.0-q);
        dist_L_opp_byage_f(i_treated,i_treated,ii,tt) = dist_L_opp_prpr(i_treated,i_treated,ii) + dist_L_opp_prpr(i_sick,i_treated,ii)*q + dist_L_opp_prpr(i_treated,i_sick,ii)*q + dist_L_opp_prpr(i_sick,i_sick,ii)*q*q;
        %Changing treatment status - young agents:
        dist_L_opp_byage_y_f(i_healthy,i_healthy,ii,tt) = dist_L_opp_y_prpr(i_healthy,i_healthy,ii);
        dist_L_opp_byage_y_f(i_healthy,i_sick,ii,tt)    = dist_L_opp_y_prpr(i_healthy,i_sick,ii)*(1.0-q);
        dist_L_opp_byage_y_f(i_healthy,i_treated,ii,tt) = dist_L_opp_y_prpr(i_healthy,i_sick,ii)*q + dist_L_opp_y_prpr(i_healthy,i_treated,ii);
        dist_L_opp_byage_y_f(i_sick,i_healthy,ii,tt)    = dist_L_opp_y_prpr(i_sick,i_healthy,ii)*(1.0-q);
        dist_L_opp_byage_y_f(i_sick,i_sick,ii,tt)       = dist_L_opp_y_prpr(i_sick,i_sick,ii)*(1.0-q)*(1.0-q);
        dist_L_opp_byage_y_f(i_sick,i_treated,ii,tt)    = dist_L_opp_y_prpr(i_sick,i_treated,ii)*(1.0-q) + dist_L_opp_y_prpr(i_sick,i_sick,ii)*(1.0-q)*q;
        dist_L_opp_byage_y_f(i_treated,i_healthy,ii,tt) = dist_L_opp_y_prpr(i_sick,i_healthy,ii)*q + dist_L_opp_y_prpr(i_treated,i_healthy,ii);
        dist_L_opp_byage_y_f(i_treated,i_sick,ii,tt)    = dist_L_opp_y_prpr(i_treated,i_sick,ii)*(1.0-q) + dist_L_opp_y_prpr(i_sick,i_sick,ii)*q*(1.0-q);
        dist_L_opp_byage_y_f(i_treated,i_treated,ii,tt) = dist_L_opp_y_prpr(i_treated,i_treated,ii) + dist_L_opp_y_prpr(i_sick,i_treated,ii)*q + dist_L_opp_y_prpr(i_treated,i_sick,ii)*q + dist_L_opp_y_prpr(i_sick,i_sick,ii)*q*q;
        %Consolidating across partner's type:
        dist_L_byage_f(:,ii,tt) = sum(dist_L_opp_byage_f(:,:,ii,tt),2);
        dist_L_byage_y_f(:,ii,tt) = sum(dist_L_opp_byage_y_f(:,:,ii,tt),2);
        %Change discount factors and treatment status for distributions by circumcision:
        if do_circ==1 
            %Change the discount factors:
            dist_L_opp_bycirc_prpr(:,:,ii) = dist_L_opp_bycirc_pr(:,:,ii) + eta*dist_L_opp_bycirc_y_pr(:,:,ii);
            dist_L_opp_bycirc_y_prpr(:,:,ii) = (1.0-eta)*dist_L_opp_bycirc_y_pr(:,:,ii);
            %Change the treatment status:
            dist_L_opp_bycirc_byage_f(i_sick,:,ii,tt) = dist_L_opp_bycirc_prpr(i_sick,:,ii)*(1.0-q);
            dist_L_opp_bycirc_byage_f(i_treated,:,ii,tt) = dist_L_opp_bycirc_prpr(i_sick,:,ii)*q + dist_L_opp_bycirc_prpr(i_treated,:,ii);
            dist_L_opp_bycirc_byage_y_f(i_sick,:,ii,tt) = dist_L_opp_bycirc_y_prpr(i_sick,:,ii)*(1.0-q);
            dist_L_opp_bycirc_byage_y_f(i_treated,:,ii,tt) = dist_L_opp_bycirc_y_prpr(i_sick,:,ii)*q + dist_L_opp_bycirc_y_prpr(i_treated,:,ii);
        end
        
        %WITH SYMPTOMS:
        dist_A_byage_f(:,ii,tt) = (1.0-delta)*( (1.0-delta2)*dist_A_apply(:,ii) + (dist_S_apply(:,ii) + dist_S_y_apply(:,ii) + dist_L_apply(:,ii) + dist_L_y_apply(:,ii)).*alpha_vec );
        
    end
        
    %UPDATE "APPLY" DISTRIBUTIONS:
    dist_S_apply = dist_S_byage_f(:,:,tt);
    dist_S_y_apply = dist_S_byage_y_f(:,:,tt);
    dist_L_apply = dist_L_byage_f(:,:,tt);
    dist_L_y_apply = dist_L_byage_y_f(:,:,tt);
    dist_L_opp_apply = dist_L_opp_byage_f(:,:,:,tt);
    dist_L_opp_y_apply = dist_L_opp_byage_y_f(:,:,:,tt);
    dist_L_opp_bycirc_apply = dist_L_opp_bycirc_byage_f(:,:,:,tt);
    dist_L_opp_bycirc_y_apply = dist_L_opp_bycirc_byage_y_f(:,:,:,tt);
    dist_A_apply = dist_A_byage_f(:,:,tt);
    
end

%Initialize distributions by age - NEVER MARRIED:
dist_S_nm_byage_f = zeros(n_status,ntypes_f,last_age);
dist_S_nm_byage_f(:,:,1) = dist_S_birth;
dist_S_nm_byage_y_f = zeros(n_status,ntypes_f,last_age);
dist_S_nm_byage_y_f(:,:,1) = dist_S_y_birth;
dist_A_nm_byage_f = zeros(n_status,ntypes_f,last_age);

%Some helpful distributions - NEVER MARRIED:
dist_S_nm_apply = dist_S_birth;
dist_S_nm_y_apply = dist_S_y_birth;
dist_A_nm_apply = dist_A_birth;

%More helpful distributions - NEVER MARRIED:
dist_S_nm_pr = zeros(n_status,ntypes_f);
dist_S_nm_y_pr = zeros(n_status,ntypes_f);
dist_S_nm_prpr = zeros(n_status,ntypes_f);
dist_S_nm_y_prpr = zeros(n_status,ntypes_f);

%Loop for distributions by age for NEVER MARRIED agents:
for tt=2:last_age
    for ii=1:ntypes_f
        %SINGLES
        %Before changing the discount factor - old agents:
        dist_S_nm_pr(i_healthy,ii) = (1-delta)*(1-pi_l_f(i_healthy,ii))*dist_S_nm_apply(i_healthy,ii)*( 1-pi_p_f(i_healthy,ii)-pi_u_f(i_healthy,ii) + pi_p_f(i_healthy,ii)*(1-upsilon_p_m*chi_f(ii)) + pi_u_f(i_healthy,ii)*(1-upsilon_u_m*chi_f(ii)) );
        dist_S_nm_pr(i_sick,ii)    = (1-delta)*( (1-pi_l_f(i_healthy,ii))*dist_S_nm_apply(i_healthy,ii)*(pi_p_f(i_healthy,ii)*upsilon_p_m*chi_f(ii)+pi_u_f(i_healthy,ii)*upsilon_u_m*chi_f(ii)) + (1-alpha)*(1-pi_l_f(i_sick,ii))*dist_S_nm_apply(i_sick,ii) );
        dist_S_nm_pr(i_treated,ii) = (1-delta)*(1-alpha_treat)*(1-pi_l_f(i_treated,ii))*dist_S_nm_apply(i_treated,ii);
        %Before changing the discount factor - young agents:
        dist_S_nm_y_pr(i_healthy,ii) = (1-delta)*(1-pi_l_y_f(i_healthy,ii))*dist_S_nm_y_apply(i_healthy,ii)*( 1-pi_p_y_f(i_healthy,ii)-pi_u_y_f(i_healthy,ii) + pi_p_y_f(i_healthy,ii)*(1-upsilon_p_m*chi_f(ii)) + pi_u_y_f(i_healthy,ii)*(1-upsilon_u_m*chi_f(ii)) );
        dist_S_nm_y_pr(i_sick,ii)    = (1-delta)*( (1-pi_l_y_f(i_healthy,ii))*dist_S_nm_y_apply(i_healthy,ii)*(pi_p_y_f(i_healthy,ii)*upsilon_p_m*chi_f(ii)+pi_u_y_f(i_healthy,ii)*upsilon_u_m*chi_f(ii)) + (1-alpha)*(1-pi_l_y_f(i_sick,ii))*dist_S_nm_y_apply(i_sick,ii) );
        dist_S_nm_y_pr(i_treated,ii) = (1-delta)*(1-alpha_treat)*(1-pi_l_y_f(i_treated,ii))*dist_S_nm_y_apply(i_treated,ii);
        %Changing the discount factor:
        dist_S_nm_prpr(:,ii) = dist_S_nm_pr(:,ii) + eta*dist_S_nm_y_pr(:,ii);
        dist_S_nm_y_prpr(:,ii) = (1.0-eta)*dist_S_nm_y_pr(:,ii);
        %Changing treatment status:
        dist_S_nm_byage_f(i_healthy,ii,tt) = dist_S_nm_prpr(i_healthy,ii);
        dist_S_nm_byage_f(i_sick,ii,tt)    = dist_S_nm_prpr(i_sick,ii)*(1.0-q);
        dist_S_nm_byage_f(i_treated,ii,tt) = dist_S_nm_prpr(i_sick,ii)*q + dist_S_nm_prpr(i_treated,ii);
        dist_S_nm_byage_y_f(i_healthy,ii,tt) = dist_S_nm_y_prpr(i_healthy,ii);
        dist_S_nm_byage_y_f(i_sick,ii,tt)    = dist_S_nm_y_prpr(i_sick,ii)*(1.0-q);
        dist_S_nm_byage_y_f(i_treated,ii,tt) = dist_S_nm_y_prpr(i_sick,ii)*q + dist_S_nm_y_prpr(i_treated,ii);
        
        %WITH SYMPTOMS:
        dist_A_nm_byage_f(:,ii,tt) = (1.0-delta)*( (1.0-delta2)*dist_A_nm_apply(:,ii) + (dist_S_nm_apply(:,ii).*(1-pi_l_f(:,ii)) + dist_S_nm_y_apply(:,ii).*(1-pi_l_y_f(:,ii))).*alpha_vec );
        
    end
        
    %UPDATE "APPLY" DISTRIBUTIONS:
    dist_S_nm_apply = dist_S_nm_byage_f(:,:,tt);
    dist_S_nm_y_apply = dist_S_nm_byage_y_f(:,:,tt);
    dist_A_nm_apply = dist_A_nm_byage_f(:,:,tt);
    
end

%Compute fraction of never-married people:
nevermarried_f = zeros(last_age,1);
for tt=1:last_age
    nevermarried_f(tt) = sum(sum( dist_S_nm_byage_f(:,:,tt)+dist_S_nm_byage_y_f(:,:,tt)+dist_A_nm_byage_f(:,:,tt) )) / ...
        sum(sum( dist_S_byage_f(:,:,tt)+dist_S_byage_y_f(:,:,tt)+dist_A_byage_f(:,:,tt)+dist_L_byage_f(:,:,tt)+dist_L_byage_y_f(:,:,tt) ));
end

evermarried_f = 1 - nevermarried_f;

% fprintf('Females - age 22 %.4f \n',evermarried_f(28))
% fprintf('Females - age 50 %.4f \n',evermarried_f(140))


% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%
%%% MOMENT 8:

% fprintf('\n\n')
% disp('----------- MOMENT 8 ----------------')
% disp('Fraction of population that has ever had sex')
% disp('-------------------------------------')

% fprintf('\n')
% disp('NOTE: Life-cycle properties in the Monte Carlo section below (if chosen)')
% disp('--------------------------------------------------------------------------')
% disp('')


%%%%%%%%%%%%%%%%%%
%%% MOMENT 9:

% fprintf('\n\n')
% disp('----------- MOMENT 9 ----------------')
% disp('Fraction of people that die from')
% disp('natural causes')
% disp('-------------------------------------')

%Males:
ahelp_numerator = delta*(sum(dist_S_all_m+dist_A_all_m+dist_L_all_m));
ahelp_denominator = sum(mu_m);
frac_natdeath_m = ahelp_numerator / ahelp_denominator;
% fprintf('Males            %.4f \n',frac_natdeath_m)

%Females:
ahelp_numerator = delta*(sum(dist_S_all_f+dist_A_all_f+dist_L_all_f));
ahelp_denominator = sum(mu_f);
frac_natdeath_f = ahelp_numerator / ahelp_denominator;
% fprintf('Females          %.4f \n',frac_natdeath_f)

%Everyone:
ahelp_numerator = delta*(sum(dist_S_all_m+dist_A_all_m+dist_L_all_m+dist_S_all_f+dist_A_all_f+dist_L_all_f));
ahelp_denominator = sum(mu_m) + sum(mu_f);
frac_natdeath = ahelp_numerator / ahelp_denominator;
% fprintf('Society          %.4f \n',frac_natdeath)

% disp('--------------------------------------------------------------------------')
% disp('')


%%%%%%%%%%%%%%%%%%
%%% MOMENT 10:

% fprintf('\n\n')
% disp('----------- MOMENT 10 ---------------')
% disp('HIV rates by age')
% disp('-------------------------------------')

%Ages that I'm interested:
%age 20: 5 years  = 20 quarters
%age 30: 15 years = 60 quarters
%age 40: 25 years = 100 quarters

%MALES:

%Collapse the type and young/old dimensions of the age distributions:
dist_S_byage_all_m = squeeze(sum(dist_S_byage_m,2)) + squeeze(sum(dist_S_byage_y_m,2));
dist_L_byage_all_m = squeeze(sum(dist_L_byage_m,2)) + squeeze(sum(dist_L_byage_y_m,2));
dist_A_byage_all_m = squeeze(sum(dist_A_byage_m,2));

%HIV rates by age:
hiv_byage_m = zeros(last_age,1);
for tt=1:last_age
    thesick = dist_S_byage_all_m(i_sick,tt) + dist_S_byage_all_m(i_treated,tt) + ...
        dist_L_byage_all_m(i_sick,tt) + dist_L_byage_all_m(i_treated,tt) + sum(dist_A_byage_all_m(:,tt));
    everyone = sum(dist_S_byage_all_m(:,tt) + dist_L_byage_all_m(:,tt) + dist_A_byage_all_m(:,tt));
    hiv_byage_m(tt) = thesick/everyone;
end

%Output:
% fprintf('Males - age 20            %.4f \n',hiv_byage_m(20))
% fprintf('Males - age 30            %.4f \n',hiv_byage_m(60))
% fprintf('Males - age 40            %.4f \n',hiv_byage_m(100))

%FEMALES:

%Collapse the type and young/old dimensions of the age distributions:
dist_S_byage_all_f = squeeze(sum(dist_S_byage_f,2)) + squeeze(sum(dist_S_byage_y_f,2));
dist_L_byage_all_f = squeeze(sum(dist_L_byage_f,2)) + squeeze(sum(dist_L_byage_y_f,2));
dist_A_byage_all_f = squeeze(sum(dist_A_byage_f,2));

%HIV rates by age:
hiv_byage_f = zeros(last_age,1);
for tt=1:last_age
    thesick = dist_S_byage_all_f(i_sick,tt) + dist_S_byage_all_f(i_treated,tt) + ...
        dist_L_byage_all_f(i_sick,tt) + dist_L_byage_all_f(i_treated,tt) + sum(dist_A_byage_all_f(:,tt));
    everyone = sum(dist_S_byage_all_f(:,tt) + dist_L_byage_all_f(:,tt) + dist_A_byage_all_f(:,tt));
    hiv_byage_f(tt) = thesick/everyone;
end

%Output:
% fprintf('Females - age 20          %.4f \n',hiv_byage_f(20))
% fprintf('Females - age 30          %.4f \n',hiv_byage_f(60))
% fprintf('Females - age 40          %.4f \n',hiv_byage_f(100))

% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% WHAT'S THE STOCK OF PEOPLE WHO ARE UNDER ART?

% fprintf('\n\n')
% disp('-------------------------------------')
% disp('Fraction of people under ART')
% disp('-------------------------------------')

%Males: 
measure_art_m = sum(dist_S_all_m(i_treated,:)+dist_L_all_m(i_treated,:)+dist_A_all_m(i_treated,:));
measure_sick_m = measure_art_m + sum(dist_S_all_m(i_sick,:)+dist_L_all_m(i_sick,:)+dist_A_all_m(i_sick,:));
fraction_art_pop_m = measure_art_m / measure_m;
fraction_art_sick_m = measure_art_m / measure_sick_m;

% fprintf('Males (over population)    %.4f \n',fraction_art_pop_m)
% fprintf('Males (over sick peole)    %.4f \n',fraction_art_sick_m)

%Females:
measure_art_f = sum(dist_S_all_f(i_treated,:)+dist_L_all_f(i_treated,:)+dist_A_all_f(i_treated,:));
measure_sick_f = measure_art_f + sum(dist_S_all_f(i_sick,:)+dist_L_all_f(i_sick,:)+dist_A_all_f(i_sick,:));
fraction_art_pop_f = measure_art_f / measure_f;
fraction_art_sick_f = measure_art_f / measure_sick_f;

% fprintf('Females (over population)  %.4f \n',fraction_art_pop_f)
% fprintf('Females (over sick peole)  %.4f \n',fraction_art_sick_f)

%Society:
fraction_art_pop = (measure_art_m+measure_art_f) / (measure_m+measure_f);
fraction_art_sick = (measure_art_m+measure_art_f) / (measure_sick_m+measure_sick_f);

% fprintf('Everyone (over population) %.4f \n',fraction_art_pop)
% fprintf('Everyone (over sick peole) %.4f \n',fraction_art_sick)

% disp('--------------------------------------------------------------------------')
% disp('')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% COMPUTE SOME LIFE CYCLE MOMENTS:

lifecycle_moments

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WELFARE  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% fprintf('\n--------------------------------------------\n')
% fprintf('--------------    WELFARE    ---------------\n')
% fprintf('--------------------------------------------\n')

%For now, Fortran is not reporting the value functions:
v_m = 0;
v_f = 0;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%EXCESS DEMANDS:

% fprintf('\n--------------------------------------------\n')
% fprintf('---------    EXCESS DEMANDS    -------------\n')
% fprintf('--------------------------------------------\n')

% fprintf('\n Market                EXCESS MALE over FEMALE\n\n')
% fprintf(' Unprotected            %.9f\n',ed_u)
% fprintf(' Protected              %.9f\n',ed_p)
% fprintf(' Long Term              %.9f\n',ed_l)

%collecting results 
results_exper = [percentage_aids percentage_aids_m hiv_byage_m(20) hiv_byage_m(60) hiv_byage_m(100) percentage_aids_f hiv_byage_f(20) hiv_byage_f(60) hiv_byage_f(100) ...
    prob_s prob_condom prob_shortsex2 prob_shortsex2_m prob_shortsex2_f fraction_single fraction_single_m fraction_single_f ...
    evermarried_m(20) evermarried_f(20) evermarried_m(28) evermarried_f(28) evermarried_m(40) evermarried_f(40) evermarried_m(140) evermarried_f(140) ...
    1-frac_natdeath fraction_art_pop fraction_art_sick ed_u ed_p ed_l value_loop_converged];

