subroutine shortterm(mytype,mygender,mystatus,ntypes,income,joy,upsilon,v_l,vtilde)
!This function computes the utility from the short term market for older agents
use mod_param
implicit none

!Define dummy variables:
integer     , intent(in)  :: mytype
integer     , intent(in)  :: mygender
integer     , intent(in)  :: mystatus
integer     , intent(in)  :: ntypes
real(mykind), intent(in)  :: income
real(mykind), intent(in)  :: joy
real(mykind), intent(in)  :: upsilon
real(mykind), intent(in)  :: v_l(n_status,ntypes)
real(mykind), intent(out) :: vtilde

!Define parameters for this problem:
real(mykind) :: beta, A, chi

!Define other variables:
real(mykind) :: util

!-----------------------------------------------------

!Get variables:
if (mygender==i_male) then
    beta = beta_m(mytype)
    A = A_m(mytype)
    chi = chi_m(mytype)
elseif (mygender==i_female) then
    beta = beta_f(mytype)
    A = A_f(mytype)
    chi = chi_f(mytype)
else
    print *, 'wrong gender in short_term'
    read *, beta
endif

!Utility from consumption:
call utility(income,util)

!Value function:
if (mystatus==i_healthy) then
    vtilde = util + joy + (1.0-upsilon*chi)*beta*v_l(i_healthy,mytype) + upsilon*chi*beta*(q*v_l(i_treated,mytype)+(1.0-q)*v_l(i_sick,mytype))
else
    vtilde = util + joy + (1.0-alpha_vec(mystatus))*beta*(q_vec(mystatus)*v_l(i_treated,mytype)+(1.0-q_vec(mystatus))*v_l(i_sick,mytype)) + alpha_vec(mystatus)*beta*A
endif

end subroutine shortterm
