subroutine shortterm_y(mytype,mygender,mystatus,ntypes,income,joy,upsilon,v_l,v_l_y,vtilde)
!This function computes the utility from the short term market for younger agents
use mod_param
implicit none

!Define dummy variables:
integer     , intent(in)  :: mytype
integer     , intent(in)  :: mygender
integer     , intent(in)  :: mystatus
integer     , intent(in)  :: ntypes
real(mykind), intent(in)  :: income
real(mykind), intent(in)  :: joy
real(mykind), intent(in)  :: upsilon
real(mykind), intent(in)  :: v_l(n_status,ntypes)
real(mykind), intent(in)  :: v_l_y(n_status,ntypes)
real(mykind), intent(out) :: vtilde

!Define parameters for this problem:
real(mykind) :: iota, A, chi

!Define other variables:
real(mykind) :: util

!-----------------------------------------------------

!Get variables:
if (mygender==i_male) then
    iota = beta_m(mytype)
    A = A_m(mytype)
    chi = chi_m(mytype)
elseif (mygender==i_female) then
    iota = beta_f(mytype)
    A = A_f(mytype)
    chi = chi_f(mytype)
else
    print *, 'wrong gender in short_term_y'
    read *, iota
endif

!Utility from consumption:
call utility(income,util)

!Value function:
if (mystatus==i_healthy) then
    vtilde = util + joy + (1.0-upsilon*chi)*iota*( eta*v_l(i_healthy,mytype) +(1.0-eta)*v_l_y(i_healthy,mytype) ) + upsilon*chi*iota*(q*( eta*v_l(i_treated,mytype) + (1.0-eta)*v_l_y(i_treated,mytype) )+(1.0-q)*( eta*v_l(i_sick,mytype) + (1.0-eta)*v_l_y(i_sick,mytype) ))
else
    vtilde = util + joy + (1.0-alpha_vec(mystatus))*iota*(q_vec(mystatus)*( eta*v_l(i_treated,mytype) + (1.0-eta)*v_l_y(i_treated,mytype) )+(1.0-q_vec(mystatus))*( eta*v_l(i_sick,mytype) + (1.0-eta)*v_l_y(i_sick,mytype) )) + alpha_vec(mystatus)*iota*A
endif

end subroutine shortterm_y
